using System;
using System.Data;

namespace DebtManagerTest
{
	/// <summary>
	/// Summary description for InvoiceListManager.
	/// </summary>
	public class InvoiceListManager: OtherListManager
	{
		protected override DebtManagerTest.DebtBaseForm getNewForm()
		{
			return new frmInvoices();
		}

		public override void FillList(System.Windows.Forms.ListView lvw, Int32 CaseID)
		{
			lvw.BeginUpdate();
			lvw.Items.Clear();
			DataTable dt = cMyDB.GetDataTable("Select InvoiceDate, InvoiceSource, InvoiceType, Amount, DatePaid, ID From Invoices Where CaseID = " + CaseID.ToString());
			foreach (DataRow dr in dt.Rows)
			{
				System.Windows.Forms.ListViewItem temp;
				if (!dr["InvoiceDate"].Equals(DBNull.Value))
					temp = lvw.Items.Add(((DateTime)dr["InvoiceDate"]).ToShortDateString());
				else
					temp = lvw.Items.Add(String.Empty);
				temp.SubItems.Add(dr["InvoiceSource"] + String.Empty);
				temp.SubItems.Add(dr["InvoiceType"] + String.Empty);
				if (!dr["Amount"].Equals(DBNull.Value))
					temp.SubItems.Add(((decimal)dr["Amount"]).ToString("c"));
				else
					temp.SubItems.Add(String.Empty);				
				if (!dr["DatePaid"].Equals(DBNull.Value))
					temp.SubItems.Add("Yes");
				else
					temp.SubItems.Add("No");
				temp.Tag = dr["ID"];
			}
			dt.Dispose();
			lvw.EndUpdate();
		}

		public override void SetupColums(System.Windows.Forms.ListView lvw)
		{
			lvw.Columns.Clear();
			lvw.Columns.Add("Invoice Date",lvw.ClientSize.Width / 4, System.Windows.Forms.HorizontalAlignment.Left);
			lvw.Columns.Add("Source",lvw.ClientSize.Width / 5, System.Windows.Forms.HorizontalAlignment.Left);
			lvw.Columns.Add("Type",lvw.ClientSize.Width / 5, System.Windows.Forms.HorizontalAlignment.Left);
			lvw.Columns.Add("Amount",lvw.ClientSize.Width / 5, System.Windows.Forms.HorizontalAlignment.Right);
			lvw.Columns.Add("Paid",lvw.ClientSize.Width * 3 / 20, System.Windows.Forms.HorizontalAlignment.Left);
			if (lvw is UtilityLibrary.WinControls.ListViewEx)
			{
				((UtilityLibrary.WinControls.ListViewEx)lvw).SetColumnSortFormat(0,UtilityLibrary.WinControls.SortedListViewFormatType.Date);
				((UtilityLibrary.WinControls.ListViewEx)lvw).SetColumnSortFormat(3,UtilityLibrary.WinControls.SortedListViewFormatType.Currency);
			}
		}
	}
}
