using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace DebtManagerTest
{
	/// <summary>
	/// Summary description for RecordConflict.
	/// </summary>
	public class RecordConflict : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Button cmdSave;
		private System.Windows.Forms.Button cmdCancel;
		private System.Windows.Forms.ListView lstDifferences;
		private System.Windows.Forms.ColumnHeader FieldName;
		private System.Windows.Forms.ColumnHeader Current;
		private System.Windows.Forms.ColumnHeader Proposed;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private DataRow mCurrentRow;
		private DataRow mProposedRow;

		public RecordConflict()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.label1 = new System.Windows.Forms.Label();
			this.panel1 = new System.Windows.Forms.Panel();
			this.cmdCancel = new System.Windows.Forms.Button();
			this.cmdSave = new System.Windows.Forms.Button();
			this.lstDifferences = new System.Windows.Forms.ListView();
			this.FieldName = new System.Windows.Forms.ColumnHeader();
			this.Current = new System.Windows.Forms.ColumnHeader();
			this.Proposed = new System.Windows.Forms.ColumnHeader();
			this.panel1.SuspendLayout();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Dock = System.Windows.Forms.DockStyle.Top;
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(440, 21);
			this.label1.TabIndex = 1;
			this.label1.Text = "This record has been changed by another user.";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// panel1
			// 
			this.panel1.Controls.AddRange(new System.Windows.Forms.Control[] {
																				 this.cmdCancel,
																				 this.cmdSave});
			this.panel1.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.panel1.Location = new System.Drawing.Point(0, 172);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(440, 36);
			this.panel1.TabIndex = 2;
			// 
			// cmdCancel
			// 
			this.cmdCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.cmdCancel.Location = new System.Drawing.Point(3, 7);
			this.cmdCancel.Name = "cmdCancel";
			this.cmdCancel.Size = new System.Drawing.Size(75, 25);
			this.cmdCancel.TabIndex = 2;
			this.cmdCancel.Text = "Cancel";
			// 
			// cmdSave
			// 
			this.cmdSave.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.cmdSave.Location = new System.Drawing.Point(354, 8);
			this.cmdSave.Name = "cmdSave";
			this.cmdSave.Size = new System.Drawing.Size(84, 25);
			this.cmdSave.TabIndex = 1;
			this.cmdSave.Text = "Save Anyway";
			// 
			// lstDifferences
			// 
			this.lstDifferences.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																							 this.FieldName,
																							 this.Current,
																							 this.Proposed});
			this.lstDifferences.Dock = System.Windows.Forms.DockStyle.Fill;
			this.lstDifferences.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
			this.lstDifferences.Location = new System.Drawing.Point(0, 21);
			this.lstDifferences.MultiSelect = false;
			this.lstDifferences.Name = "lstDifferences";
			this.lstDifferences.Size = new System.Drawing.Size(440, 151);
			this.lstDifferences.TabIndex = 0;
			this.lstDifferences.View = System.Windows.Forms.View.Details;
			// 
			// FieldName
			// 
			this.FieldName.Text = "Field Name";
			this.FieldName.Width = 110;
			// 
			// Current
			// 
			this.Current.Text = "Database Data";
			this.Current.Width = 150;
			// 
			// Proposed
			// 
			this.Proposed.Text = "Your Values";
			this.Proposed.Width = 150;
			// 
			// RecordConflict
			// 
			this.AcceptButton = this.cmdSave;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.cmdCancel;
			this.ClientSize = new System.Drawing.Size(440, 208);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.lstDifferences,
																		  this.panel1,
																		  this.label1});
			this.Name = "RecordConflict";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Caution recommended";
			this.panel1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		public DataRow CurrentRow
		{
			get
			{
				return mCurrentRow;
			}
			set
			{
				mCurrentRow = value;
			}
		}
		public DataRow ProposedRow
		{
			get
			{
				return mProposedRow;
			}
			set
			{
				mProposedRow = value;
			}
		}
		public void Compare(DataRow Current, DataRow Proposed)
		{
			ProposedRow = Proposed;
			CurrentRow = Current;
			Compare();
		}
		public void Compare()
		{
			//Check that we have data and it is the same
			if (ProposedRow == null || CurrentRow == null)
				throw new ApplicationException("The data supplied is either invalid or has not been supplied");			
			if (ProposedRow.ItemArray.Length != CurrentRow.ItemArray.Length)
				throw new ApplicationException("The two sets of data cannot be compared as they have a different number fields");
			
			lstDifferences.Items.Clear();
			for (int i = 0; i < CurrentRow.ItemArray.Length; i++)
			{
				try 
				{
					if (!CurrentRow[i].Equals(ProposedRow[i]))
					{						
						lstDifferences.Items.Add(new ListViewItem(new string[] { CurrentRow.Table.Columns[i].ColumnName,Convert.ToString( CurrentRow[i]),Convert.ToString( ProposedRow[i])}));
					}
				}
				catch (Exception e )
				{
					MessageBox.Show("Error " + e.Message);
				}
			}
		}
	}
}
