using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Data.OleDb;


namespace DebtManagerTest
{
	/// <summary>
	/// Summary description for frmCompanies.
	/// </summary>
	public class frmCompanies : System.Windows.Forms.Form
	{
		private Crownwood.Magic.Controls.TabControl tabControl1;
		private System.Windows.Forms.Label lblStatus;
		private UtilityLibrary.WinControls.ButtonEx cmdOK;
		private UtilityLibrary.WinControls.ButtonEx cmdCancel;
		private Crownwood.Magic.Controls.TabPage tabGeneral;
		private Crownwood.Magic.Controls.TabPage tabNotes;
		private Crownwood.Magic.Controls.TabPage tabValidity;
		private System.Windows.Forms.TextBox txtNotes;
		private System.Windows.Forms.CheckBox checkBox1;
		private System.Windows.Forms.CheckBox checkBox2;
		private System.Windows.Forms.CheckBox checkBox3;
		private System.Windows.Forms.CheckBox checkBox4;
		private System.Windows.Forms.CheckBox checkBox5;
		private System.Windows.Forms.CheckBox checkBox6;
		private System.Windows.Forms.CheckBox checkBox7;
		private System.Windows.Forms.CheckBox checkBox8;
		private System.Windows.Forms.CheckBox checkBox9;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.TextBox textBox2;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.TextBox textBox3;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.TextBox textBox4;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.TextBox textBox5;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.TextBox textBox6;
		private DebtManagerTest.dsCompanies dsCompanies1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Label label3;
		private UtilityLibrary.WinControls.ButtonEx cmdEdit;
		private bool Adding = false;

		public frmCompanies()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			this.tabGeneral.BindingContext = this.BindingContext;
			this.tabNotes.BindingContext = this.BindingContext;
			this.tabValidity.BindingContext = this.BindingContext;
		}

		public void EditCompany(string ShortName)
		{
            dsCompanies1.Merge(CCompanies.GetRowFromShortName(ShortName));
			if (!dsCompanies1.Companies.Rows[0]["LastUpdated"].Equals(DBNull.Value))
				this.lblStatus.Text = "Last Updated " + ((DateTime)dsCompanies1.Companies.Rows[0]["LastUpdated"]).ToShortDateString() + " By " + (dsCompanies1.Companies.Rows[0]["LastUser"] + "");
		}

		public void NewCompany(bool Housing,
			bool Endowment,		
			bool Indemnity,
			bool Valuer,
			bool SecondCharge,
			bool Creditor,
			bool EstateAgent,
			bool InvoiceSource,
			bool Employer)
		{
			dsCompanies.CompaniesRow myNewRow = dsCompanies1.Companies.NewCompaniesRow();
			myNewRow["ShortName"] = "";
			myNewRow["ValidForHousingAssociation"] = Housing;
			myNewRow["ValidForEndowmentCompany"] = Endowment;
			myNewRow["ValidForIndemnityCompany"] = Indemnity;
			myNewRow["ValidForValuer"] = Valuer;
			myNewRow["ValidForSecondCharge"] = SecondCharge;
			myNewRow["ValidForCreditor"] = Creditor;
			myNewRow["ValidForEstateAgent"] = EstateAgent;
			myNewRow["ValidForInvoiceSource"] = InvoiceSource;
			myNewRow["ValidForEmployer"] = Employer;
			myNewRow["Created"] = DateTime.Now;
			myNewRow["CreateUser"] = CSession.User.Username;
			dsCompanies1.Companies.AddCompaniesRow(myNewRow);
			Adding = true;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.tabControl1 = new Crownwood.Magic.Controls.TabControl();
			this.tabGeneral = new Crownwood.Magic.Controls.TabPage();
			this.cmdEdit = new UtilityLibrary.WinControls.ButtonEx();
			this.label3 = new System.Windows.Forms.Label();
			this.textBox6 = new System.Windows.Forms.TextBox();
			this.dsCompanies1 = new DebtManagerTest.dsCompanies();
			this.label7 = new System.Windows.Forms.Label();
			this.textBox5 = new System.Windows.Forms.TextBox();
			this.label6 = new System.Windows.Forms.Label();
			this.textBox4 = new System.Windows.Forms.TextBox();
			this.label5 = new System.Windows.Forms.Label();
			this.textBox3 = new System.Windows.Forms.TextBox();
			this.label4 = new System.Windows.Forms.Label();
			this.textBox2 = new System.Windows.Forms.TextBox();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.tabNotes = new Crownwood.Magic.Controls.TabPage();
			this.txtNotes = new System.Windows.Forms.TextBox();
			this.tabValidity = new Crownwood.Magic.Controls.TabPage();
			this.label1 = new System.Windows.Forms.Label();
			this.checkBox7 = new System.Windows.Forms.CheckBox();
			this.checkBox8 = new System.Windows.Forms.CheckBox();
			this.checkBox9 = new System.Windows.Forms.CheckBox();
			this.checkBox4 = new System.Windows.Forms.CheckBox();
			this.checkBox5 = new System.Windows.Forms.CheckBox();
			this.checkBox6 = new System.Windows.Forms.CheckBox();
			this.checkBox3 = new System.Windows.Forms.CheckBox();
			this.checkBox2 = new System.Windows.Forms.CheckBox();
			this.checkBox1 = new System.Windows.Forms.CheckBox();
			this.lblStatus = new System.Windows.Forms.Label();
			this.cmdOK = new UtilityLibrary.WinControls.ButtonEx();
			this.cmdCancel = new UtilityLibrary.WinControls.ButtonEx();
			this.tabControl1.SuspendLayout();
			this.tabGeneral.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.dsCompanies1)).BeginInit();
			this.tabNotes.SuspendLayout();
			this.tabValidity.SuspendLayout();
			this.SuspendLayout();
			// 
			// tabControl1
			// 
			this.tabControl1.Controls.AddRange(new System.Windows.Forms.Control[] {
																					  this.tabGeneral,
																					  this.tabNotes,
																					  this.tabValidity});
			this.tabControl1.Dock = System.Windows.Forms.DockStyle.Top;
			this.tabControl1.Font = new System.Drawing.Font("Tahoma", 11F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.World, ((System.Byte)(0)));
			this.tabControl1.Name = "tabControl1";
			this.tabControl1.PositionTop = true;
			this.tabControl1.SelectedIndex = 0;
			this.tabControl1.SelectedTab = this.tabGeneral;
			this.tabControl1.Size = new System.Drawing.Size(333, 232);
			this.tabControl1.TabIndex = 0;
			this.tabControl1.TabPages.AddRange(new Crownwood.Magic.Controls.TabPage[] {
																						  this.tabGeneral,
																						  this.tabNotes,
																						  this.tabValidity});
			this.tabControl1.SelectionChanged += new System.EventHandler(this.tabControl1_SelectionChanged);
			// 
			// tabGeneral
			// 
			this.tabGeneral.Controls.AddRange(new System.Windows.Forms.Control[] {
																					 this.cmdEdit,
																					 this.label3,
																					 this.textBox6,
																					 this.label7,
																					 this.textBox5,
																					 this.label6,
																					 this.textBox4,
																					 this.label5,
																					 this.textBox3,
																					 this.label4,
																					 this.textBox2,
																					 this.textBox1,
																					 this.label2});
			this.tabGeneral.Location = new System.Drawing.Point(0, 25);
			this.tabGeneral.Name = "tabGeneral";
			this.tabGeneral.Size = new System.Drawing.Size(333, 207);
			this.tabGeneral.TabIndex = 3;
			this.tabGeneral.Title = "General";
			// 
			// cmdEdit
			// 
			this.cmdEdit.CausesValidation = false;
			this.cmdEdit.Location = new System.Drawing.Point(194, 19);
			this.cmdEdit.Name = "cmdEdit";
			this.cmdEdit.Size = new System.Drawing.Size(33, 19);
			this.cmdEdit.TabIndex = 13;
			this.cmdEdit.Text = "Edit";
			this.cmdEdit.Visible = false;
			this.cmdEdit.Click += new System.EventHandler(this.cmdEdit_Click);
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(8, 45);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(71, 15);
			this.label3.TabIndex = 12;
			this.label3.Text = "Full Name";
			this.label3.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// textBox6
			// 
			this.textBox6.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsCompanies1, "Companies.Email"));
			this.textBox6.Location = new System.Drawing.Point(89, 170);
			this.textBox6.Name = "textBox6";
			this.textBox6.Size = new System.Drawing.Size(229, 21);
			this.textBox6.TabIndex = 11;
			this.textBox6.Text = "";
			// 
			// dsCompanies1
			// 
			this.dsCompanies1.DataSetName = "dsCompanies";
			this.dsCompanies1.Locale = new System.Globalization.CultureInfo("en-GB");
			this.dsCompanies1.Namespace = "http://www.tempuri.org/dsCompanies.xsd";
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(7, 172);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(70, 19);
			this.label7.TabIndex = 10;
			this.label7.Text = "Email";
			this.label7.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// textBox5
			// 
			this.textBox5.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsCompanies1, "Companies.FullName"));
			this.textBox5.Location = new System.Drawing.Point(89, 42);
			this.textBox5.Name = "textBox5";
			this.textBox5.Size = new System.Drawing.Size(229, 21);
			this.textBox5.TabIndex = 2;
			this.textBox5.Text = "";
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(7, 148);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(70, 19);
			this.label6.TabIndex = 8;
			this.label6.Text = "Telephone";
			this.label6.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// textBox4
			// 
			this.textBox4.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsCompanies1, "Companies.TelephoneNo"));
			this.textBox4.Location = new System.Drawing.Point(89, 146);
			this.textBox4.Name = "textBox4";
			this.textBox4.Size = new System.Drawing.Size(159, 21);
			this.textBox4.TabIndex = 7;
			this.textBox4.Text = "";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(7, 125);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(70, 16);
			this.label5.TabIndex = 6;
			this.label5.Text = "Post Code";
			this.label5.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// textBox3
			// 
			this.textBox3.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsCompanies1, "Companies.PostCode"));
			this.textBox3.Location = new System.Drawing.Point(89, 122);
			this.textBox3.Name = "textBox3";
			this.textBox3.Size = new System.Drawing.Size(159, 21);
			this.textBox3.TabIndex = 5;
			this.textBox3.Text = "";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(7, 69);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(70, 13);
			this.label4.TabIndex = 4;
			this.label4.Text = "Address";
			this.label4.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// textBox2
			// 
			this.textBox2.AcceptsReturn = true;
			this.textBox2.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsCompanies1, "Companies.Address"));
			this.textBox2.Location = new System.Drawing.Point(89, 66);
			this.textBox2.Multiline = true;
			this.textBox2.Name = "textBox2";
			this.textBox2.Size = new System.Drawing.Size(229, 53);
			this.textBox2.TabIndex = 3;
			this.textBox2.Text = "";
			// 
			// textBox1
			// 
			this.textBox1.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsCompanies1, "Companies.ShortName"));
			this.textBox1.Location = new System.Drawing.Point(89, 18);
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(101, 21);
			this.textBox1.TabIndex = 1;
			this.textBox1.Text = "";
			this.textBox1.Validating += new System.ComponentModel.CancelEventHandler(this.textBox1_Validating);
			this.textBox1.TextChanged += new System.EventHandler(this.textBox1_TextChanged);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(7, 21);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(71, 15);
			this.label2.TabIndex = 0;
			this.label2.Text = "Short Name";
			this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// tabNotes
			// 
			this.tabNotes.Controls.AddRange(new System.Windows.Forms.Control[] {
																				   this.txtNotes});
			this.tabNotes.Location = new System.Drawing.Point(0, 25);
			this.tabNotes.Name = "tabNotes";
			this.tabNotes.Selected = false;
			this.tabNotes.Size = new System.Drawing.Size(333, 207);
			this.tabNotes.StartFocus = this.tabNotes;
			this.tabNotes.TabIndex = 4;
			this.tabNotes.Title = "Notes";
			// 
			// txtNotes
			// 
			this.txtNotes.AcceptsReturn = true;
			this.txtNotes.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsCompanies1, "Companies.Notes"));
			this.txtNotes.Dock = System.Windows.Forms.DockStyle.Fill;
			this.txtNotes.Multiline = true;
			this.txtNotes.Name = "txtNotes";
			this.txtNotes.Size = new System.Drawing.Size(333, 207);
			this.txtNotes.TabIndex = 0;
			this.txtNotes.Text = "";
			// 
			// tabValidity
			// 
			this.tabValidity.Controls.AddRange(new System.Windows.Forms.Control[] {
																					  this.label1,
																					  this.checkBox7,
																					  this.checkBox8,
																					  this.checkBox9,
																					  this.checkBox4,
																					  this.checkBox5,
																					  this.checkBox6,
																					  this.checkBox3,
																					  this.checkBox2,
																					  this.checkBox1});
			this.tabValidity.Location = new System.Drawing.Point(0, 25);
			this.tabValidity.Name = "tabValidity";
			this.tabValidity.Selected = false;
			this.tabValidity.Size = new System.Drawing.Size(333, 207);
			this.tabValidity.TabIndex = 5;
			this.tabValidity.Title = "Menu Visibility";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(12, 21);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(306, 22);
			this.label1.TabIndex = 9;
			this.label1.Text = "Select all the lists you would like this company to appear in.";
			// 
			// checkBox7
			// 
			this.checkBox7.DataBindings.Add(new System.Windows.Forms.Binding("Checked", this.dsCompanies1, "Companies.ValidForEmployer"));
			this.checkBox7.Location = new System.Drawing.Point(14, 149);
			this.checkBox7.Name = "checkBox7";
			this.checkBox7.Size = new System.Drawing.Size(134, 24);
			this.checkBox7.TabIndex = 8;
			this.checkBox7.Text = "Employers";
			this.checkBox7.Visible = false;
			// 
			// checkBox8
			// 
			this.checkBox8.DataBindings.Add(new System.Windows.Forms.Binding("Checked", this.dsCompanies1, "Companies.ValidForInvoiceSource"));
			this.checkBox8.Location = new System.Drawing.Point(179, 104);
			this.checkBox8.Name = "checkBox8";
			this.checkBox8.Size = new System.Drawing.Size(134, 24);
			this.checkBox8.TabIndex = 5;
			this.checkBox8.Text = "Invoice Sources";
			// 
			// checkBox9
			// 
			this.checkBox9.DataBindings.Add(new System.Windows.Forms.Binding("Checked", this.dsCompanies1, "Companies.ValidForEstateAgent"));
			this.checkBox9.Location = new System.Drawing.Point(179, 82);
			this.checkBox9.Name = "checkBox9";
			this.checkBox9.Size = new System.Drawing.Size(134, 24);
			this.checkBox9.TabIndex = 3;
			this.checkBox9.Text = "Estate Agents";
			// 
			// checkBox4
			// 
			this.checkBox4.DataBindings.Add(new System.Windows.Forms.Binding("Checked", this.dsCompanies1, "Companies.ValidForCreditor"));
			this.checkBox4.Location = new System.Drawing.Point(179, 151);
			this.checkBox4.Name = "checkBox4";
			this.checkBox4.Size = new System.Drawing.Size(134, 24);
			this.checkBox4.TabIndex = 5;
			this.checkBox4.Text = "Creditors";
			this.checkBox4.Visible = false;
			// 
			// checkBox5
			// 
			this.checkBox5.DataBindings.Add(new System.Windows.Forms.Binding("Checked", this.dsCompanies1, "Companies.ValidForSecondCharge"));
			this.checkBox5.Location = new System.Drawing.Point(179, 61);
			this.checkBox5.Name = "checkBox5";
			this.checkBox5.Size = new System.Drawing.Size(134, 24);
			this.checkBox5.TabIndex = 1;
			this.checkBox5.Text = "Second Charges";
			// 
			// checkBox6
			// 
			this.checkBox6.DataBindings.Add(new System.Windows.Forms.Binding("Checked", this.dsCompanies1, "Companies.ValidForIndemnityCompany"));
			this.checkBox6.Location = new System.Drawing.Point(14, 105);
			this.checkBox6.Name = "checkBox6";
			this.checkBox6.Size = new System.Drawing.Size(134, 24);
			this.checkBox6.TabIndex = 4;
			this.checkBox6.Text = "Indemnity Companies";
			// 
			// checkBox3
			// 
			this.checkBox3.DataBindings.Add(new System.Windows.Forms.Binding("Checked", this.dsCompanies1, "Companies.ValidForValuer"));
			this.checkBox3.Location = new System.Drawing.Point(14, 127);
			this.checkBox3.Name = "checkBox3";
			this.checkBox3.Size = new System.Drawing.Size(134, 24);
			this.checkBox3.TabIndex = 6;
			this.checkBox3.Text = "Valuers";
			// 
			// checkBox2
			// 
			this.checkBox2.DataBindings.Add(new System.Windows.Forms.Binding("Checked", this.dsCompanies1, "Companies.ValidForEndowmentCompany"));
			this.checkBox2.Location = new System.Drawing.Point(14, 83);
			this.checkBox2.Name = "checkBox2";
			this.checkBox2.Size = new System.Drawing.Size(154, 24);
			this.checkBox2.TabIndex = 2;
			this.checkBox2.Text = "Endowment Companies";
			// 
			// checkBox1
			// 
			this.checkBox1.DataBindings.Add(new System.Windows.Forms.Binding("Checked", this.dsCompanies1, "Companies.ValidForHousingAssociation"));
			this.checkBox1.Location = new System.Drawing.Point(14, 61);
			this.checkBox1.Name = "checkBox1";
			this.checkBox1.Size = new System.Drawing.Size(134, 24);
			this.checkBox1.TabIndex = 0;
			this.checkBox1.Text = "Housing Associations";
			// 
			// lblStatus
			// 
			this.lblStatus.Location = new System.Drawing.Point(4, 244);
			this.lblStatus.Name = "lblStatus";
			this.lblStatus.Size = new System.Drawing.Size(166, 27);
			this.lblStatus.TabIndex = 17;
			// 
			// cmdOK
			// 
			this.cmdOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.cmdOK.Location = new System.Drawing.Point(173, 247);
			this.cmdOK.Name = "cmdOK";
			this.cmdOK.Size = new System.Drawing.Size(68, 23);
			this.cmdOK.TabIndex = 16;
			this.cmdOK.Text = "OK";
			this.cmdOK.Click += new System.EventHandler(this.cmdOK_Click);
			this.cmdOK.Validating += new System.ComponentModel.CancelEventHandler(this.cmdOK_Validating);
			// 
			// cmdCancel
			// 
			this.cmdCancel.CausesValidation = false;
			this.cmdCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.cmdCancel.Location = new System.Drawing.Point(248, 247);
			this.cmdCancel.Name = "cmdCancel";
			this.cmdCancel.Size = new System.Drawing.Size(70, 23);
			this.cmdCancel.TabIndex = 18;
			this.cmdCancel.Text = "Cancel";
			// 
			// frmCompanies
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.cmdCancel;
			this.ClientSize = new System.Drawing.Size(333, 278);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.lblStatus,
																		  this.cmdOK,
																		  this.cmdCancel,
																		  this.tabControl1});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "frmCompanies";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Company Details";
			this.Load += new System.EventHandler(this.frmCompanies_Load);
			this.Validating += new System.ComponentModel.CancelEventHandler(this.frmCompanies_Validating);
			this.tabControl1.ResumeLayout(false);
			this.tabGeneral.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.dsCompanies1)).EndInit();
			this.tabNotes.ResumeLayout(false);
			this.tabValidity.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void cmdOK_Click(object sender, System.EventArgs e)
		{
			this.BindingContext[dsCompanies1, "Companies"].EndCurrentEdit();
			if (dsCompanies1.Companies.Rows[0].RowState != DataRowState.Unchanged)
			{
				dsCompanies1.Companies.Rows[0]["LastUpdated"] = DateTime.Now;
				dsCompanies1.Companies.Rows[0]["LastUser"] = CSession.User.Username;
				CCompanies.DataAdapter.Update(dsCompanies1, "Companies");
			}
		}

		private void textBox1_Validating(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if (textBox1.Text.Length > 0 && (Adding || !dsCompanies1.Companies.Rows[0]["ShortName", DataRowVersion.Original].Equals(textBox1.Text))) 
			{
				OleDbCommand cmd = new OleDbCommand();
				cmd.CommandText = "Select ShortName From Companies Where ShortName = ?";
				cmd.Parameters.Add(CUtil.NewParam("Name", OleDbType.VarWChar, textBox1.Text));
				if (!cMyDB.IsEmpty(cmd))
				{
					MessageBox.Show("The company short name entered already exists. Please choose a unique name, or click the edit button to edit the existing company. Your changes to the current record will be discarded.", "Input Error");
					this.cmdEdit.Visible = true;
					e.Cancel = true;
				}
			}
			else
			{
				if (textBox1.Text.Length == 0)
				{
					MessageBox.Show("Please choose a name for this company.", "Input Error");
					e.Cancel = true;
				}
			}
			if (e.Cancel !=true)
				this.cmdEdit.Visible = false;
		}

		private void textBox1_TextChanged(object sender, System.EventArgs e)
		{
			if (this.cmdEdit.Visible == true)
				this.cmdEdit.Visible = false;
		}

		private void cmdEdit_Click(object sender, System.EventArgs e)
		{
			string temp = this.textBox1.Text;
			dsCompanies1.Companies.Clear();
			dsCompanies1.Merge(CCompanies.GetRowFromShortName(temp));
			if (!dsCompanies1.Companies.Rows[0]["LastUpdated"].Equals(DBNull.Value))
				this.lblStatus.Text = "Last Updated " + ((DateTime)dsCompanies1.Companies.Rows[0]["LastUpdated"]).ToShortDateString() + " By " + (dsCompanies1.Companies.Rows[0]["LastUser"] + "");
			Adding = false;
		}

		private void cmdOK_Validating(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if (this.textBox5.Text.Length == 0)
				e.Cancel = true;
		}

		private void frmCompanies_Validating(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if (this.textBox5.Text.Length == 0)
				e.Cancel = true;
		}

		private void tabControl1_SelectionChanged(object sender, System.EventArgs e)
		{
		
		}

		private void frmCompanies_Load(object sender, System.EventArgs e)
		{
			this.tabGeneral.Select();
			this.textBox1.Select();
		}
	}
}
