using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Data.OleDb;

namespace DebtManagerTest
{
	/// <summary>
	/// Summary description for frmCompleteDiary.
	/// </summary>
	public class frmCompleteDiary : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label lblStatus;
		private UtilityLibrary.WinControls.ButtonEx cmdOK;
		private UtilityLibrary.WinControls.ButtonEx cmdCancel;
		private Crownwood.Magic.Controls.TabControl tabs;
		private Crownwood.Magic.Controls.TabPage tpDetails;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.TextBox txtDescription;
		private System.Windows.Forms.Label label2;
		private DebtManagerTest.LookupComboObjects.LookupCombo cboActionType;
		private Crownwood.Magic.Controls.TabPage tpNotes;
		private System.Windows.Forms.TextBox txtNotes;
		private System.Windows.Forms.MonthCalendar dtDateActioned;
		private DebtManagerTest.InterfaceComponents.dsDiary dsDiary1;
		private System.Windows.Forms.DateTimePicker dtpActionDate;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.ComboBox cboCases;
		private System.Windows.Forms.Label label5;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private bool Adding = false;

		public Int32 CaseID
		{
			get
			{
				if (dsDiary1.Diary.Count> 0)
				{
					if (dsDiary1.Diary[0].IsCaseIDNull())
						return -1;
					else
						return dsDiary1.Diary[0].CaseID;
				}
				return -1;
			}
		}

		public frmCompleteDiary()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}
		private void PrepGeneral()
		{
			DataTable dtCases = cMyDB.GetDataTable("Select ID, AccountNumber From Cases");
			DataRow dr = dtCases.NewRow();
			dr.BeginEdit();
			dr["ID"] = -1;
			dr["AccountNumber"] = "All Cases";
			dr.EndEdit();
			dtCases.Rows.InsertAt(dr,0);
			foreach (DataRow dr2 in dtCases.Rows)
			{
				if(dr2[1].Equals(DBNull.Value))
					dr2[1] = "A/C Not Specified " + dr2[0].ToString();
			}
			cboCases.DataSource = dtCases;			
			cboCases.ValueMember = "ID";
			cboCases.DisplayMember = "AccountNumber";
			
			this.dtpActionDate.Value = DateTime.Today;
			dtDateActioned.SetDate(DateTime.Today);
		}

		public void PrepForInsert(Int32 CaseID)
		{
			PrepForInsert();
			dsDiary1.Diary.Rows[0].BeginEdit();
			dsDiary1.Diary.Rows[0]["CaseID"] = CaseID;
			dsDiary1.Diary.Rows[0].EndEdit();
			if (this.cboCases.Items.Count > 2)
			{
				if (this.CaseID > 0)
					cboCases.SelectedValue = this.CaseID;	
			}
			else
			{
				if (this.CaseID > 0)
					cboCases.SelectedIndex = 1;
			}
		}

		public void PrepForInsert()
		{
			PrepGeneral();
			Adding = true;
			this.Text = "Journal Entry";
			DebtManagerTest.InterfaceComponents.dsDiary.DiaryRow dr = dsDiary1.Diary.NewDiaryRow();
			dr.BeginEdit();
			dr.ActionDate = DateTime.Today;
			dr.ActionType = 0;
			dr.EndEdit();
			dsDiary1.Diary.AddDiaryRow(dr);
			//if (this.CaseID > 0)
			//	cboCases.SelectedValue = this.CaseID;
		}

		public void PrepForEdit(Int32 DiaryID)
		{
			PrepGeneral();
			CDiary.MainAdapter.SelectCommand.Parameters["id"].Value = DiaryID;
			CDiary.MainAdapter.Fill(dsDiary1, "Diary");
			if (dsDiary1.Diary.Rows.Count < 1)
			{
				OleDbCommand cmd = new OleDbCommand("Select ID from Diary Where ID = ?");
				cmd.Parameters.Add(CUtil.NewParam("ID", OleDbType.Integer, DiaryID));
				if(cMyDB.IsEmpty(cmd))
				{
					MessageBox.Show("The item selected cannot be displayed, it has been deleted by another user.", "Data not available");
				}
				else
				{
					MessageBox.Show("The item selected cannot be displayed due to a data problem.", "Data not available");
				}
				cmd.Dispose();
				this.Close();
			}
			if (!dsDiary1.Diary.Rows[0]["DateActioned"].Equals(DBNull.Value))
			{
				this.dtDateActioned.SelectionEnd = (DateTime)dsDiary1.Diary.Rows[0]["DateActioned"];
			}
			if (!dsDiary1.Diary.Rows[0]["LastUpdated"].Equals(DBNull.Value))
			{
				this.lblStatus.Text = "Last Updated " + ((DateTime)dsDiary1.Diary.Rows[0]["LastUpdated"]).ToShortDateString() + " By " + (dsDiary1.Diary.Rows[0]["LastUser"] + "");
			}
			if (this.CaseID > 0)
				cboCases.SelectedValue = this.CaseID;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.lblStatus = new System.Windows.Forms.Label();
			this.cmdOK = new UtilityLibrary.WinControls.ButtonEx();
			this.cmdCancel = new UtilityLibrary.WinControls.ButtonEx();
			this.tabs = new Crownwood.Magic.Controls.TabControl();
			this.tpDetails = new Crownwood.Magic.Controls.TabPage();
			this.label5 = new System.Windows.Forms.Label();
			this.cboCases = new System.Windows.Forms.ComboBox();
			this.dsDiary1 = new DebtManagerTest.InterfaceComponents.dsDiary();
			this.label4 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.dtpActionDate = new System.Windows.Forms.DateTimePicker();
			this.label3 = new System.Windows.Forms.Label();
			this.txtDescription = new System.Windows.Forms.TextBox();
			this.dtDateActioned = new System.Windows.Forms.MonthCalendar();
			this.label2 = new System.Windows.Forms.Label();
			this.cboActionType = new DebtManagerTest.LookupComboObjects.LookupCombo();
			this.tpNotes = new Crownwood.Magic.Controls.TabPage();
			this.txtNotes = new System.Windows.Forms.TextBox();
			this.tabs.SuspendLayout();
			this.tpDetails.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.dsDiary1)).BeginInit();
			this.tpNotes.SuspendLayout();
			this.SuspendLayout();
			// 
			// lblStatus
			// 
			this.lblStatus.Location = new System.Drawing.Point(6, 332);
			this.lblStatus.Name = "lblStatus";
			this.lblStatus.Size = new System.Drawing.Size(141, 27);
			this.lblStatus.TabIndex = 14;
			// 
			// cmdOK
			// 
			this.cmdOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.cmdOK.Location = new System.Drawing.Point(152, 334);
			this.cmdOK.Name = "cmdOK";
			this.cmdOK.Size = new System.Drawing.Size(68, 23);
			this.cmdOK.TabIndex = 13;
			this.cmdOK.Text = "OK";
			this.cmdOK.Click += new System.EventHandler(this.cmdOK_Click);
			// 
			// cmdCancel
			// 
			this.cmdCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.cmdCancel.Location = new System.Drawing.Point(227, 334);
			this.cmdCancel.Name = "cmdCancel";
			this.cmdCancel.Size = new System.Drawing.Size(70, 23);
			this.cmdCancel.TabIndex = 15;
			this.cmdCancel.Text = "Cancel";
			// 
			// tabs
			// 
			this.tabs.Controls.AddRange(new System.Windows.Forms.Control[] {
																			   this.tpDetails,
																			   this.tpNotes});
			this.tabs.Dock = System.Windows.Forms.DockStyle.Top;
			this.tabs.Font = new System.Drawing.Font("Tahoma", 11F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.World, ((System.Byte)(0)));
			this.tabs.Name = "tabs";
			this.tabs.PositionTop = true;
			this.tabs.SelectedIndex = 0;
			this.tabs.SelectedTab = this.tpDetails;
			this.tabs.Size = new System.Drawing.Size(313, 325);
			this.tabs.TabIndex = 12;
			this.tabs.TabPages.AddRange(new Crownwood.Magic.Controls.TabPage[] {
																				   this.tpDetails,
																				   this.tpNotes});
			// 
			// tpDetails
			// 
			this.tpDetails.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.label5,
																					this.cboCases,
																					this.label4,
																					this.label1,
																					this.dtpActionDate,
																					this.label3,
																					this.txtDescription,
																					this.dtDateActioned,
																					this.label2,
																					this.cboActionType});
			this.tpDetails.Location = new System.Drawing.Point(0, 25);
			this.tpDetails.Name = "tpDetails";
			this.tpDetails.Size = new System.Drawing.Size(313, 300);
			this.tpDetails.TabIndex = 3;
			this.tpDetails.Title = "Diary Entry Details";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(38, 35);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(41, 13);
			this.label5.TabIndex = 19;
			this.label5.Text = "Case";
			this.label5.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// cboCases
			// 
			this.cboCases.Location = new System.Drawing.Point(91, 31);
			this.cboCases.Name = "cboCases";
			this.cboCases.TabIndex = 18;
			// 
			// dsDiary1
			// 
			this.dsDiary1.DataSetName = "dsDiary";
			this.dsDiary1.Locale = new System.Globalization.CultureInfo("en-GB");
			this.dsDiary1.Namespace = "http://www.tempuri.org/dsDiary.xsd";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(25, 126);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(58, 30);
			this.label4.TabIndex = 17;
			this.label4.Text = "Date Completed";
			this.label4.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(25, 58);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(58, 23);
			this.label1.TabIndex = 16;
			this.label1.Text = "Diary Date";
			this.label1.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// dtpActionDate
			// 
			this.dtpActionDate.DataBindings.Add(new System.Windows.Forms.Binding("Value", this.dsDiary1, "Diary.ActionDate"));
			this.dtpActionDate.Format = System.Windows.Forms.DateTimePickerFormat.Short;
			this.dtpActionDate.Location = new System.Drawing.Point(91, 56);
			this.dtpActionDate.Name = "dtpActionDate";
			this.dtpActionDate.Size = new System.Drawing.Size(122, 21);
			this.dtpActionDate.TabIndex = 15;
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(43, 85);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(40, 23);
			this.label3.TabIndex = 14;
			this.label3.Text = "Details";
			this.label3.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// txtDescription
			// 
			this.txtDescription.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsDiary1, "Diary.Description"));
			this.txtDescription.Location = new System.Drawing.Point(90, 81);
			this.txtDescription.Multiline = true;
			this.txtDescription.Name = "txtDescription";
			this.txtDescription.Size = new System.Drawing.Size(200, 41);
			this.txtDescription.TabIndex = 3;
			this.txtDescription.Text = "";
			// 
			// dtDateActioned
			// 
			this.dtDateActioned.BackColor = System.Drawing.SystemColors.Window;
			this.dtDateActioned.Location = new System.Drawing.Point(91, 128);
			this.dtDateActioned.MaxSelectionCount = 1;
			this.dtDateActioned.Name = "dtDateActioned";
			this.dtDateActioned.TabIndex = 5;
			this.dtDateActioned.TitleBackColor = System.Drawing.SystemColors.Control;
			this.dtDateActioned.TitleForeColor = System.Drawing.SystemColors.MenuText;
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(46, 11);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(37, 23);
			this.label2.TabIndex = 11;
			this.label2.Text = "Action";
			this.label2.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// cboActionType
			// 
			this.cboActionType.AllowUpdates = true;
			this.cboActionType.ComboValue = null;
			this.cboActionType.DataBindings.Add(new System.Windows.Forms.Binding("SelectedValue", this.dsDiary1, "Diary.ActionType"));
			this.cboActionType.DataBound = true;
			this.cboActionType.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cboActionType.ExtraRefreshes = true;
			this.cboActionType.Location = new System.Drawing.Point(91, 7);
			this.cboActionType.LookupID = "ActionType";
			this.cboActionType.Name = "cboActionType";
			this.cboActionType.Nullable = true;
			this.cboActionType.TabIndex = 2;
			// 
			// tpNotes
			// 
			this.tpNotes.Controls.AddRange(new System.Windows.Forms.Control[] {
																				  this.txtNotes});
			this.tpNotes.Location = new System.Drawing.Point(0, 25);
			this.tpNotes.Name = "tpNotes";
			this.tpNotes.Selected = false;
			this.tpNotes.Size = new System.Drawing.Size(313, 300);
			this.tpNotes.TabIndex = 4;
			this.tpNotes.Title = "Notes";
			this.tpNotes.Visible = false;
			// 
			// txtNotes
			// 
			this.txtNotes.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsDiary1, "Diary.Notes"));
			this.txtNotes.Dock = System.Windows.Forms.DockStyle.Fill;
			this.txtNotes.Multiline = true;
			this.txtNotes.Name = "txtNotes";
			this.txtNotes.Size = new System.Drawing.Size(313, 300);
			this.txtNotes.TabIndex = 0;
			this.txtNotes.Text = "";
			// 
			// frmCompleteDiary
			// 
			this.AcceptButton = this.cmdOK;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.cmdCancel;
			this.ClientSize = new System.Drawing.Size(313, 363);
			this.ControlBox = false;
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.lblStatus,
																		  this.cmdOK,
																		  this.cmdCancel,
																		  this.tabs});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "frmCompleteDiary";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Complete Diary Entry";
			this.tabs.ResumeLayout(false);
			this.tpDetails.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.dsDiary1)).EndInit();
			this.tpNotes.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void cmdOK_Click(object sender, System.EventArgs e)
		{
			try
			{				
				dsDiary1.Diary.Rows[0]["DateActioned"] = this.dtDateActioned.SelectionEnd;
				dsDiary1.Diary.Rows[0]["Completed"] = true;
				dsDiary1.Diary.Rows[0]["LastUpdated"] = DateTime.Now;
				dsDiary1.Diary.Rows[0]["LastUser"] = CSession.User.Username;
				
				if (!((Int32)cboCases.SelectedValue).Equals(-1))
					dsDiary1.Diary[0].CaseID = (Int32)cboCases.SelectedValue;
				else
					dsDiary1.Diary[0].SetCaseIDNull();

				if (Adding)
				{
					dsDiary1.Diary.Rows[0]["UserID"] = CSession.User.UserID;
					dsDiary1.Diary.Rows[0]["Created"] = DateTime.Now;
					dsDiary1.Diary.Rows[0]["CreateUser"] = CSession.User.Username;
				}
	
				dsDiary1.Diary[0].EndEdit();
				//this.BindingContext[dsDiary1,"Diary"].EndCurrentEdit();
				CDiary.MainAdapter.Update(dsDiary1, "Diary");
			}
			catch (Exception er)
			{
				MessageBox.Show(er.Message);
			}
		}
	}
}
