using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.IO;

namespace DebtManagerTest
{
	/// <summary>
	/// Summary description for frmConfig.
	/// </summary>
	public class frmConfig : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Button cmdOK;
		private System.Windows.Forms.TextBox txtDB;
		private System.Windows.Forms.TextBox txtLetters;
		private System.Windows.Forms.TextBox txtWord;
		public System.Windows.Forms.Button cmdWord;
		public System.Windows.Forms.Button cmdLetters;
		public System.Windows.Forms.Button cmdDB;
		private System.Windows.Forms.Label label4;
		public System.Windows.Forms.Button cmdSavePath;
		private System.Windows.Forms.TextBox txtSavePath;
		private System.Windows.Forms.CheckBox chkAlwaysSave;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.CheckBox chkEdits;
		private System.Windows.Forms.Button cmdCancel;
		private bool ForceRestart = false;

		public frmConfig()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			txtDB.Text = CSession.DBPath;
			txtLetters.Text = CSession.LetterPath;
			txtWord.Text = CSession.WordAppPath;
			txtSavePath.Text = CSession.SavePath;
			chkAlwaysSave.Checked = CSession.AlwaysSave;
			chkEdits.Checked = CSession.DisallowEdits;
			CheckValues();
		}
		public frmConfig(bool forceRestart):this()
		{
			ForceRestart = forceRestart;
		}

		private void CheckValues()
		{
			cmdOK.Enabled = (txtDB.Text != string.Empty) && (txtDB.Text != null);
			cmdOK.Enabled = (txtLetters.Text != string.Empty) && (txtLetters.Text != null);
			cmdOK.Enabled = (txtWord.Text != string.Empty) && (txtWord.Text != null);
			cmdOK.Enabled = (txtSavePath.Text != string.Empty) && (txtSavePath.Text != null);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.cmdOK = new System.Windows.Forms.Button();
			this.txtDB = new System.Windows.Forms.TextBox();
			this.txtLetters = new System.Windows.Forms.TextBox();
			this.txtWord = new System.Windows.Forms.TextBox();
			this.cmdWord = new System.Windows.Forms.Button();
			this.cmdLetters = new System.Windows.Forms.Button();
			this.cmdDB = new System.Windows.Forms.Button();
			this.cmdSavePath = new System.Windows.Forms.Button();
			this.txtSavePath = new System.Windows.Forms.TextBox();
			this.label4 = new System.Windows.Forms.Label();
			this.chkAlwaysSave = new System.Windows.Forms.CheckBox();
			this.chkEdits = new System.Windows.Forms.CheckBox();
			this.cmdCancel = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(112, 13);
			this.label1.TabIndex = 0;
			this.label1.Text = "Database File";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 45);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(112, 13);
			this.label2.TabIndex = 1;
			this.label2.Text = "Letter Directory";
			this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(8, 125);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(112, 13);
			this.label3.TabIndex = 2;
			this.label3.Text = "Microsoft Word (.exe)";
			this.label3.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// cmdOK
			// 
			this.cmdOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.cmdOK.Enabled = false;
			this.cmdOK.Location = new System.Drawing.Point(198, 158);
			this.cmdOK.Name = "cmdOK";
			this.cmdOK.TabIndex = 3;
			this.cmdOK.Text = "OK";
			this.cmdOK.Click += new System.EventHandler(this.cmdOK_Click);
			// 
			// txtDB
			// 
			this.txtDB.Enabled = false;
			this.txtDB.Location = new System.Drawing.Point(127, 14);
			this.txtDB.Name = "txtDB";
			this.txtDB.Size = new System.Drawing.Size(213, 20);
			this.txtDB.TabIndex = 4;
			this.txtDB.Text = "";
			// 
			// txtLetters
			// 
			this.txtLetters.Enabled = false;
			this.txtLetters.Location = new System.Drawing.Point(127, 42);
			this.txtLetters.Name = "txtLetters";
			this.txtLetters.Size = new System.Drawing.Size(213, 20);
			this.txtLetters.TabIndex = 5;
			this.txtLetters.Text = "";
			// 
			// txtWord
			// 
			this.txtWord.Enabled = false;
			this.txtWord.Location = new System.Drawing.Point(127, 121);
			this.txtWord.Name = "txtWord";
			this.txtWord.Size = new System.Drawing.Size(213, 20);
			this.txtWord.TabIndex = 6;
			this.txtWord.Text = "";
			// 
			// cmdWord
			// 
			this.cmdWord.AccessibleRole = System.Windows.Forms.AccessibleRole.None;
			this.cmdWord.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.cmdWord.Location = new System.Drawing.Point(342, 121);
			this.cmdWord.Name = "cmdWord";
			this.cmdWord.Size = new System.Drawing.Size(18, 20);
			this.cmdWord.TabIndex = 7;
			this.cmdWord.Text = "...";
			this.cmdWord.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.cmdWord.Click += new System.EventHandler(this.cmdWord_Click);
			// 
			// cmdLetters
			// 
			this.cmdLetters.AccessibleRole = System.Windows.Forms.AccessibleRole.None;
			this.cmdLetters.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.cmdLetters.Location = new System.Drawing.Point(342, 42);
			this.cmdLetters.Name = "cmdLetters";
			this.cmdLetters.Size = new System.Drawing.Size(18, 20);
			this.cmdLetters.TabIndex = 8;
			this.cmdLetters.Text = "...";
			this.cmdLetters.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.cmdLetters.Click += new System.EventHandler(this.cmdLetters_Click);
			// 
			// cmdDB
			// 
			this.cmdDB.AccessibleRole = System.Windows.Forms.AccessibleRole.None;
			this.cmdDB.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.cmdDB.Location = new System.Drawing.Point(342, 14);
			this.cmdDB.Name = "cmdDB";
			this.cmdDB.Size = new System.Drawing.Size(18, 20);
			this.cmdDB.TabIndex = 9;
			this.cmdDB.Text = "...";
			this.cmdDB.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.cmdDB.Click += new System.EventHandler(this.cmdDB_Click);
			// 
			// cmdSavePath
			// 
			this.cmdSavePath.AccessibleRole = System.Windows.Forms.AccessibleRole.None;
			this.cmdSavePath.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.cmdSavePath.Location = new System.Drawing.Point(342, 70);
			this.cmdSavePath.Name = "cmdSavePath";
			this.cmdSavePath.Size = new System.Drawing.Size(18, 20);
			this.cmdSavePath.TabIndex = 12;
			this.cmdSavePath.Text = "...";
			this.cmdSavePath.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.cmdSavePath.Click += new System.EventHandler(this.cmdSavePath_Click);
			// 
			// txtSavePath
			// 
			this.txtSavePath.Enabled = false;
			this.txtSavePath.Location = new System.Drawing.Point(127, 70);
			this.txtSavePath.Name = "txtSavePath";
			this.txtSavePath.Size = new System.Drawing.Size(213, 20);
			this.txtSavePath.TabIndex = 11;
			this.txtSavePath.Text = "";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(8, 73);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(112, 13);
			this.label4.TabIndex = 10;
			this.label4.Text = "Default Save Path";
			this.label4.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// chkAlwaysSave
			// 
			this.chkAlwaysSave.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.chkAlwaysSave.Location = new System.Drawing.Point(7, 94);
			this.chkAlwaysSave.Name = "chkAlwaysSave";
			this.chkAlwaysSave.Size = new System.Drawing.Size(133, 24);
			this.chkAlwaysSave.TabIndex = 13;
			this.chkAlwaysSave.Text = "Always Save Letters?";
			// 
			// chkEdits
			// 
			this.chkEdits.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.chkEdits.Location = new System.Drawing.Point(145, 95);
			this.chkEdits.Name = "chkEdits";
			this.chkEdits.Size = new System.Drawing.Size(197, 22);
			this.chkEdits.TabIndex = 14;
			this.chkEdits.Text = "Disallow Editing/Opening Letters?";
			// 
			// cmdCancel
			// 
			this.cmdCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.cmdCancel.Location = new System.Drawing.Point(285, 158);
			this.cmdCancel.Name = "cmdCancel";
			this.cmdCancel.TabIndex = 15;
			this.cmdCancel.Text = "Cancel";
			this.cmdCancel.Click += new System.EventHandler(this.cmdCancel_Click);
			// 
			// frmConfig
			// 
			this.AcceptButton = this.cmdOK;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.cmdCancel;
			this.ClientSize = new System.Drawing.Size(371, 191);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.cmdCancel,
																		  this.chkEdits,
																		  this.chkAlwaysSave,
																		  this.cmdSavePath,
																		  this.txtSavePath,
																		  this.label4,
																		  this.cmdDB,
																		  this.cmdLetters,
																		  this.cmdWord,
																		  this.txtWord,
																		  this.txtLetters,
																		  this.txtDB,
																		  this.cmdOK,
																		  this.label3,
																		  this.label2,
																		  this.label1});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Name = "frmConfig";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "System Configuration";
			this.ResumeLayout(false);

		}
		#endregion

		private void cmdDB_Click(object sender, System.EventArgs e)
		{
			OpenFileDialog OpenFileDlg = new OpenFileDialog();
			OpenFileDlg.RestoreDirectory = true;
			if (txtDB.Text !="")
			{
				DirectoryInfo dI = new DirectoryInfo(txtDB.Text);
				if (dI.Exists)
				{
					OpenFileDlg.InitialDirectory = dI.FullName;
					OpenFileDlg.FileName = "";
				}
				else
				{
					FileInfo fI = new FileInfo(txtDB.Text);
					if (fI.Exists)
					{
						OpenFileDlg.FileName = txtDB.Text;
					}
					else
					{
						OpenFileDlg.FileName = "";
					}
				}
			}
			else
				OpenFileDlg.FileName = "";

			OpenFileDlg.Title = "Specify Database Location";
			OpenFileDlg.Filter = "Microsoft Access Database Files|*.mdb";
			OpenFileDlg.FilterIndex = 1;
			OpenFileDlg.Multiselect = false;

			if (OpenFileDlg.ShowDialog() == DialogResult.OK)
				txtDB.Text = OpenFileDlg.FileName;
			
			CheckValues();
			OpenFileDlg.Dispose();
		}

		private void cmdLetters_Click(object sender, System.EventArgs e)
		{
			CP.Windows.Forms.ShellFolderBrowser fb = new CP.Windows.Forms.ShellFolderBrowser();
			if (txtLetters.Text !="")
			{
				DirectoryInfo dI = new DirectoryInfo(txtLetters.Text);
				if (dI.Exists)
				{
					fb.FolderPath = txtLetters.Text;
				}
			}
			fb.Title = "Select Letters Directory";
			if(fb.ShowDialog())
			{
				if (fb.FolderPath!="")
				{
					txtLetters.Text = fb.FolderPath;
				}
			}
			fb.Dispose();
			CheckValues();
		}

		private void cmdWord_Click(object sender, System.EventArgs e)
		{
			OpenFileDialog OpenFileDlg = new OpenFileDialog();
			OpenFileDlg.RestoreDirectory = true;
			if (txtWord.Text !="")
			{
				DirectoryInfo dI = new DirectoryInfo(txtWord.Text);
				if (dI.Exists)
				{
					OpenFileDlg.InitialDirectory = dI.FullName;
					OpenFileDlg.FileName = "";
				}
				else
				{
					FileInfo fI = new FileInfo(txtWord.Text);
					if (fI.Exists)
					{
						OpenFileDlg.FileName = txtWord.Text;
					}
					else
					{
						OpenFileDlg.FileName = "";
					}
				}
			}
			else
				OpenFileDlg.FileName = "";

			OpenFileDlg.Title = "Specify Database Location";
			OpenFileDlg.Filter = "Microsoft Word Executable Files|winword.exe";
			OpenFileDlg.FilterIndex = 1;
			OpenFileDlg.Multiselect = false;

			if (OpenFileDlg.ShowDialog() == DialogResult.OK)
				txtWord.Text = OpenFileDlg.FileName;
			
			CheckValues();
			OpenFileDlg.Dispose();
		}

		private void cmdOK_Click(object sender, System.EventArgs e)
		{
			CSession.SaveConfig(txtDB.Text, txtLetters.Text, txtSavePath.Text, txtWord.Text, chkAlwaysSave.Checked, chkEdits.Checked);
			if (ForceRestart)
				MessageBox.Show("The Changes will not come into effect until you restart the system.", "Configuration Changed");
			else
				CSession.GetConfig();
		}

		private void cmdSavePath_Click(object sender, System.EventArgs e)
		{
			CP.Windows.Forms.ShellFolderBrowser fb = new CP.Windows.Forms.ShellFolderBrowser();
			if (txtSavePath.Text !="")
			{
				DirectoryInfo dI = new DirectoryInfo(txtSavePath.Text);
				if (dI.Exists)
				{
					fb.FolderPath = txtSavePath.Text;
				}
			}
			fb.Title = "Select Save Directory";
			if(fb.ShowDialog())
			{
				if (fb.FolderPath!="")
				{
					txtSavePath.Text = fb.FolderPath;
				}
			}
			fb.Dispose();
			CheckValues();
		}

		private void cmdCancel_Click(object sender, System.EventArgs e)
		{
		
		}
	}
}
