using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace DebtManagerTest
{
	/// <summary>
	/// Summary description for frmLookupSettings.
	/// </summary>
	public class frmLookupSettings : System.Windows.Forms.Form
	{
		private UtilityLibrary.WinControls.ButtonEx cmdClose;
		private Crownwood.Magic.Menus.MenuCommand mnuRefresh;
		private System.Windows.Forms.ColumnHeader columnHeader1;
		private System.Windows.Forms.ColumnHeader columnHeader2;
		private Crownwood.Magic.Menus.MenuCommand mnuEdit;
		private UtilityLibrary.WinControls.ListViewEx lvwLookups;
		private System.Windows.Forms.Label label1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private Crownwood.Magic.Menus.PopupMenu pm;

		public frmLookupSettings()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			lvwLookups.Columns[0].Width = lvwLookups.Width * 2/5;
			lvwLookups.Columns[1].Width = lvwLookups.Width * 2/5;

			pm = new Crownwood.Magic.Menus.PopupMenu();
			pm.MenuCommands.Add(mnuEdit);
			pm.MenuCommands.Add(mnuRefresh);
			
			FillLookupList();
		}

		private void FillLookupList()
		{
			lvwLookups.Items.Clear();
			DataTable dt = cMyDB.GetDataTable("Select LookupDefinitions.ID, b.Description, SecurityLevel From LookupDefinitions Inner Join UserLevelLookup as b on LookupDefinitions.SecurityLevel = b.ID Where Updateable = true");
			foreach (DataRow dr in dt.Rows)
			{
				ListViewItem temp = lvwLookups.Items.Add(dr["ID"].ToString());
				temp.SubItems.Add(dr["Description"].ToString());
				temp.Tag = dr["SecurityLevel"];
			}
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.cmdClose = new UtilityLibrary.WinControls.ButtonEx();
			this.mnuRefresh = new Crownwood.Magic.Menus.MenuCommand();
			this.lvwLookups = new UtilityLibrary.WinControls.ListViewEx();
			this.columnHeader1 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader2 = new System.Windows.Forms.ColumnHeader();
			this.mnuEdit = new Crownwood.Magic.Menus.MenuCommand();
			this.label1 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// cmdClose
			// 
			this.cmdClose.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right);
			this.cmdClose.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.cmdClose.Location = new System.Drawing.Point(250, 240);
			this.cmdClose.Name = "cmdClose";
			this.cmdClose.TabIndex = 3;
			this.cmdClose.Text = "Close ";
			// 
			// mnuRefresh
			// 
			this.mnuRefresh.Description = "Refresh this list";
			this.mnuRefresh.Text = "&Refresh";
			this.mnuRefresh.Click += new System.EventHandler(this.mnuRefresh_Click);
			// 
			// lvwLookups
			// 
			this.lvwLookups.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.lvwLookups.CheckBookEvenRowBackColor = System.Drawing.Color.Empty;
			this.lvwLookups.CheckBookEvenRowForeColor = System.Drawing.Color.Empty;
			this.lvwLookups.CheckBookLookEnabled = false;
			this.lvwLookups.CheckBookOddRowBackColor = System.Drawing.Color.Empty;
			this.lvwLookups.CheckBookOddRowForeColor = System.Drawing.Color.Empty;
			this.lvwLookups.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						 this.columnHeader1,
																						 this.columnHeader2});
			this.lvwLookups.FullRowSelect = true;
			this.lvwLookups.HeaderColor = System.Drawing.Color.Empty;
			this.lvwLookups.HeaderImageList = null;
			this.lvwLookups.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
			this.lvwLookups.Location = new System.Drawing.Point(6, 6);
			this.lvwLookups.MultiSelect = false;
			this.lvwLookups.Name = "lvwLookups";
			this.lvwLookups.PaintSortedColumnBackground = true;
			this.lvwLookups.Size = new System.Drawing.Size(319, 226);
			this.lvwLookups.SortingEnabled = true;
			this.lvwLookups.SortOrder = System.Windows.Forms.SortOrder.Ascending;
			this.lvwLookups.TabIndex = 2;
			this.lvwLookups.View = System.Windows.Forms.View.Details;
			this.lvwLookups.Resize += new System.EventHandler(this.lvwLookups_Resize);
			this.lvwLookups.MouseUp += new System.Windows.Forms.MouseEventHandler(this.lvwLookups_MouseUp);
			// 
			// columnHeader1
			// 
			this.columnHeader1.Text = "Lookup Name";
			// 
			// columnHeader2
			// 
			this.columnHeader2.Text = "User Level";
			// 
			// mnuEdit
			// 
			this.mnuEdit.Description = "Edit";
			this.mnuEdit.Text = "&Edit";
			this.mnuEdit.Click += new System.EventHandler(this.mnuEdit_Click);
			// 
			// label1
			// 
			this.label1.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.label1.Location = new System.Drawing.Point(8, 237);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(206, 28);
			this.label1.TabIndex = 4;
			this.label1.Text = "Changes will not take effect until the system is restarted";
			// 
			// frmLookupSettings
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(329, 270);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.label1,
																		  this.cmdClose,
																		  this.lvwLookups});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Name = "frmLookupSettings";
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Hide;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Lookup List Security";
			this.ResumeLayout(false);

		}
		#endregion

		private void lvwLookups_Resize(object sender, System.EventArgs e)
		{
			lvwLookups.Columns[0].Width = lvwLookups.Width * 2/5;
			lvwLookups.Columns[1].Width = lvwLookups.Width * 2/5;
		}

		private void lvwLookups_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if (e.Button == MouseButtons.Right)
			{
				if (lvwLookups.GetItemAt(e.X,e.Y)!=null)
				{
					lvwLookups.Tag = lvwLookups.GetItemAt(e.X,e.Y).Text;
					if (Convert.ToInt32(lvwLookups.GetItemAt(e.X,e.Y).Tag) > CSession.User.UserLevel)
						mnuEdit.Visible = false;
					else
						mnuEdit.Visible = true;
				}
				else
				{
					mnuEdit.Visible = false;
				}
				pm.TrackPopup(lvwLookups.PointToScreen(new Point(e.X,e.Y)));
			}
		}

		private void mnuEdit_Click(object sender, System.EventArgs e)
		{
			frmLookup frm = new frmLookup(lvwLookups.Tag.ToString());
			if (frm.ShowDialog() == DialogResult.OK)
				FillLookupList();
			frm.Dispose();
		}

		private void mnuRefresh_Click(object sender, System.EventArgs e)
		{
			FillLookupList();
		}

	}
}
