using System;
using System.Data;

namespace DebtManagerTest
{
	/// <summary>
	/// Summary description for HoldCodeListManager.
	/// </summary>
	public class HoldCodeListManager: OtherListManager
	{
		protected override DebtManagerTest.DebtBaseForm getNewForm()
		{
			return new frmHoldCodes();
		}

		public override void FillList(System.Windows.Forms.ListView lvw, Int32 CaseID)
		{
			lvw.BeginUpdate();
			lvw.Items.Clear();
			DataTable dt = cMyDB.GetDataTable("Select HoldCode, b.Description as FullText, DateSet, User, HoldCodes.ID From HoldCodes Inner Join HoldCodeLookup as b on HoldCodes.HoldCode = b.ID Where CaseID = " + CaseID.ToString());
			foreach (DataRow dr in dt.Rows)
			{
				System.Windows.Forms.ListViewItem temp;
				temp = lvw.Items.Add(dr["HoldCode"] + String.Empty);
				temp.SubItems.Add(dr["FullText"] + String.Empty);
				if (!dr["DateSet"].Equals(DBNull.Value))
				{
					temp.SubItems.Add(((DateTime)dr["DateSet"]).ToShortDateString() + "");
					temp.SubItems.Add(dr["User"] + "");
				}
				temp.Tag = dr["ID"];
			}
			dt.Dispose();
			lvw.EndUpdate();
		}

		public override void SetupColums(System.Windows.Forms.ListView lvw)
		{
			lvw.Columns.Clear();
			lvw.Columns.Add("Hold Code",lvw.ClientSize.Width / 6, System.Windows.Forms.HorizontalAlignment.Left);
			lvw.Columns.Add("Description",lvw.ClientSize.Width / 3, System.Windows.Forms.HorizontalAlignment.Left);
			lvw.Columns.Add("Date Set",lvw.ClientSize.Width / 4, System.Windows.Forms.HorizontalAlignment.Left);
			lvw.Columns.Add("Set By",lvw.ClientSize.Width / 4, System.Windows.Forms.HorizontalAlignment.Right);
			if (lvw is UtilityLibrary.WinControls.ListViewEx)
				((UtilityLibrary.WinControls.ListViewEx)lvw).SetColumnSortFormat(3,UtilityLibrary.WinControls.SortedListViewFormatType.Date);
		}		
	}
}
