using System;
using System.Data;

namespace DebtManagerTest
{
	/// <summary>
	/// Summary description for LetterListManager.
	/// </summary>
	public class LetterListManager : OtherListManager
	{
		protected override DebtManagerTest.DebtBaseForm getNewForm()
		{
			return new frmLetters();
		}

		public override void FillList(System.Windows.Forms.ListView lvw, Int32 CaseID)
		{
			lvw.BeginUpdate();
			lvw.Items.Clear();
			DataTable dt = cMyDB.GetDataTable("Select LetterDate, b.Description as LetterType, Saved, Edited, Letters.ID From Letters Inner Join LetterTypeLookup as b on Letters.LetterType = b.ID Where CaseID = " + CaseID.ToString());
			foreach (DataRow dr in dt.Rows)
			{
				System.Windows.Forms.ListViewItem temp;
				if (!dr["LetterDate"].Equals(DBNull.Value))
					temp = lvw.Items.Add(((DateTime)dr["LetterDate"]).ToShortDateString() + "");
				else
					continue;
				temp.SubItems.Add(dr["LetterType"] + String.Empty);
				if (dr["Saved"].Equals(true))
					temp.SubItems.Add("Yes");
				else
					temp.SubItems.Add("No");
				if (dr["Edited"].Equals(true))
					temp.SubItems.Add("Yes");
				else
					temp.SubItems.Add("No");
				temp.Tag = dr["ID"];
			}
			dt.Dispose();
			lvw.EndUpdate();
		}

		public override void SetupColums(System.Windows.Forms.ListView lvw)
		{
			lvw.Columns.Clear();
			lvw.Columns.Add("Letter Date",lvw.ClientSize.Width / 4, System.Windows.Forms.HorizontalAlignment.Left);
			lvw.Columns.Add("Letter Type",lvw.ClientSize.Width / 2, System.Windows.Forms.HorizontalAlignment.Left);
			lvw.Columns.Add("Saved",lvw.ClientSize.Width / 8, System.Windows.Forms.HorizontalAlignment.Left);
			lvw.Columns.Add("Edited",lvw.ClientSize.Width / 8, System.Windows.Forms.HorizontalAlignment.Right);
			if (lvw is UtilityLibrary.WinControls.ListViewEx)
				((UtilityLibrary.WinControls.ListViewEx)lvw).SetColumnSortFormat(0,UtilityLibrary.WinControls.SortedListViewFormatType.Date);
		}
	}
}
