using System;
using System.Data;

namespace DebtManagerTest
{
	/// <summary>
	/// Summary description for ValuationListManager.
	/// </summary>
	public class ValuationListManager: OtherListManager
	{
		protected override DebtManagerTest.DebtBaseForm getNewForm()
		{
			return new frmValuations();
		}

		public override void FillList(System.Windows.Forms.ListView lvw, Int32 CaseID)
		{
			lvw.BeginUpdate();
			lvw.Items.Clear();
			DataTable dt = cMyDB.GetDataTable("Select ValuationDate, b.Description as ValType, Valuer, Valuation, Valuations.ID From Valuations Inner Join ValuationTypeLookup as b on Valuations.ValuationType = b.ID Where CaseID = " + CaseID.ToString());
			foreach (DataRow dr in dt.Rows)
			{
				System.Windows.Forms.ListViewItem temp;
				if (!dr["ValuationDate"].Equals(DBNull.Value))
					temp = lvw.Items.Add(((DateTime)dr["ValuationDate"]).ToShortDateString() + "");
				else
					continue;
				//temp = lvw.Items.Add("Date Not Specified");
				temp.SubItems.Add(dr["ValType"] + String.Empty);
				temp.SubItems.Add(dr["Valuer"] + String.Empty);
                if (!dr["Valuation"].Equals(DBNull.Value))
					temp.SubItems.Add(((decimal)dr["Valuation"]).ToString("c"));
				else
					temp.SubItems.Add(String.Empty);
				temp.Tag = dr["ID"];
			}
			dt.Dispose();
			lvw.EndUpdate();
		}

		public override void SetupColums(System.Windows.Forms.ListView lvw)
		{
			lvw.Columns.Clear();
			lvw.Columns.Add("Valuation Date",lvw.ClientSize.Width / 4, System.Windows.Forms.HorizontalAlignment.Left);
			lvw.Columns.Add("Valuation Type",lvw.ClientSize.Width / 4, System.Windows.Forms.HorizontalAlignment.Left);
			lvw.Columns.Add("Valuer",lvw.ClientSize.Width / 4, System.Windows.Forms.HorizontalAlignment.Left);
			lvw.Columns.Add("Valuation",lvw.ClientSize.Width / 4, System.Windows.Forms.HorizontalAlignment.Right);
			if (lvw is UtilityLibrary.WinControls.ListViewEx)
				((UtilityLibrary.WinControls.ListViewEx)lvw).SetColumnSortFormat(0,UtilityLibrary.WinControls.SortedListViewFormatType.Date);
		}
	}
}
