using System;
using System.Data;

namespace DebtManagerTest
{
	/// <summary>
	/// Summary description for VisitListManager.
	/// </summary>
	public class VisitListManager : OtherListManager
	{
		protected override DebtManagerTest.DebtBaseForm getNewForm()
		{
			return new frmVisits();
		}

		public override void FillList(System.Windows.Forms.ListView lvw, Int32 CaseID)
		{
			lvw.BeginUpdate();
			lvw.Items.Clear();
			DataTable dt = cMyDB.GetDataTable("Select VisitDate, VisitMadeBy, Comments, ID From Visits Where CaseID = " + CaseID.ToString());
			foreach (DataRow dr in dt.Rows)
			{
				System.Windows.Forms.ListViewItem temp;
				if (!dr["VisitDate"].Equals(DBNull.Value))
					temp = lvw.Items.Add(((DateTime)dr["VisitDate"]).ToShortDateString() + "");
				else
					temp = lvw.Items.Add("Date Not Specified");
				temp.SubItems.Add(dr["VisitMadeBy"] + "");
				temp.SubItems.Add(dr["Comments"] + "");
				temp.Tag = dr["ID"];
			}
			dt.Dispose();
			lvw.EndUpdate();
		}

		public override void SetupColums(System.Windows.Forms.ListView lvw)
		{
			lvw.Columns.Clear();
			lvw.Columns.Add("Visit Date",lvw.ClientSize.Width / 4, System.Windows.Forms.HorizontalAlignment.Left);
			lvw.Columns.Add("By",lvw.ClientSize.Width / 4, System.Windows.Forms.HorizontalAlignment.Left);
			lvw.Columns.Add("Comments",lvw.ClientSize.Width / 2, System.Windows.Forms.HorizontalAlignment.Left);
			if (lvw is UtilityLibrary.WinControls.ListViewEx)
				((UtilityLibrary.WinControls.ListViewEx)lvw).SetColumnSortFormat(0,UtilityLibrary.WinControls.SortedListViewFormatType.Date);				
		}
	}
}
