using System;
using System.Data;
using System.Collections;
using System.Data.OleDb;
using System.IO;
using System.Configuration;

namespace DebtManagerTest
{
	/// <summary>
	/// Static class used to allow data access from everywhere.
	/// </summary>
	public class cMyDB
	{
		private static string conn;
		private static OleDbConnection db;

		public static void CleanUp()
		{
			db.Dispose();
		}

		public static void FillDS(DataSet toFill, OleDbDataAdapter adapter)
		{
			try
			{
				adapter.SelectCommand.Connection = db;
				db.Open();
				adapter.Fill(toFill);
				adapter.SelectCommand.Connection = null;
			}
			catch (Exception e)
			{
				throw e;
			}
			finally
			{
				db.Close();
			}
		}
		public static void FillDS(DataSet toFill,string table_name, OleDbDataAdapter adapter)
		{
			try
			{
				adapter.SelectCommand.Connection = db;
				db.Open();
				adapter.Fill(toFill, table_name);
				adapter.SelectCommand.Connection = null;
			}
			catch (Exception e)
			{
				throw e;
			}
			finally
			{
				db.Close();
			}
		}

		public static void FillDS(DataSet toFill, OleDbCommand command)
		{
			command.Connection = db;
			OleDbDataAdapter da = new OleDbDataAdapter(command);
			try
			{
				db.Open();
				da.Fill(toFill);
			}
			catch (Exception e)
			{
				throw e;
			}
			finally
			{
				command.Connection = null;
				db.Close();
			}
			da.Dispose();
		}

		public static void FillDS(DataSet toFill, string sql)
		{
			OleDbDataAdapter da = new OleDbDataAdapter(sql, db);
			try
			{
				db.Open();
				da.Fill(toFill);
			}
			catch (Exception e)
			{
				throw e;
			}
			finally
			{
				db.Close();
			}
			da.Dispose();
		}

		public static OleDbConnection NewConnection()
		{
			return new OleDbConnection(conn);
		}

		public static string GetConnectionString()
		{
			return conn;
		}
		public static void Initialise() 
		{
			conn = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + CSession.DBPath;
			db = new OleDbConnection(GetConnectionString());
		}
		public static DataTable GetDataTable(string strSelectCommand)
		{
			OleDbDataAdapter da = new OleDbDataAdapter(strSelectCommand,db);
			DataTable dt = new DataTable();
			try
			{
				db.Open();
				da.Fill(dt);
			}
			catch (Exception e)
			{
				throw e;
			}
			finally
			{
				db.Close();
			}
			da.Dispose();
			return dt;
		}
		public static DataSet GetDataSet(string strSelectCommand)
		{
			OleDbDataAdapter da = new OleDbDataAdapter(strSelectCommand,db);
			DataSet ds = new DataSet();
			try
			{
				db.Open();
				da.Fill(ds);
			}
			catch (Exception e)
			{
				throw e;
			}
			finally
			{
				db.Close();
			}
			da.Dispose();
			return ds;
		}
		public static DataSet GetDataSet(OleDbCommand cmd)
		{
			cmd.Connection = db;
			OleDbDataAdapter da = new OleDbDataAdapter(cmd);
			DataSet ds = new DataSet();
			try
			{
				db.Open();
				da.Fill(ds);
			}
			catch (Exception e)
			{
				throw e;
			}
			finally
			{
				db.Close();
			}
			da.Dispose();
			return ds;
		}
		public static string ConnectionString()
		{
			return conn;
		}
		public static object GetResult(string strSelectCommand)
		{
			OleDbCommand dc = new OleDbCommand(strSelectCommand,db);
			object returnVal;
			try
			{
				db.Open();
				returnVal = dc.ExecuteScalar();
			}
			catch (Exception e)
			{
				throw e;
			}
			finally
			{
				db.Close();
			}
			dc.Dispose();
			return returnVal;
		}
		public static object GetResult(OleDbCommand cmd)
		{
			object returnVal;
			try
			{
				cmd.Connection = db;
				db.Open();
				returnVal = cmd.ExecuteScalar();
			}
			catch (Exception e)
			{
				throw e;
			}
			finally
			{
				db.Close();
			}
			return returnVal;
		}
		public static bool IsEmpty(OleDbCommand cmd)
		{
			object returnVal;
			try
			{
				cmd.Connection = db;
				db.Open();
				returnVal = cmd.ExecuteScalar();
			}
			catch (Exception e)
			{
				throw e;
			}
			finally
			{
				db.Close();
			}
			return (returnVal == null);
		}
		public static bool IsEmpty(string strSQL)
		{
			OleDbCommand dc = new OleDbCommand(strSQL,db);
			object returnVal;
			try
			{
				db.Open();
				returnVal = dc.ExecuteScalar();
			}
			catch (Exception e)
			{
				throw e;
			}
			finally
			{
				db.Close();
			}
			dc.Dispose();
			return (returnVal == null);
		}
		public static int ExecuteInsertAndGetID(OleDbCommand cmd)
		{
			object returnVal = null;
			try
			{
				cmd.Connection = db;
				db.Open();
				cmd.ExecuteNonQuery();
				OleDbCommand getKey = new OleDbCommand("SELECT @@IDENTITY", db);
				returnVal = getKey.ExecuteScalar();
				getKey.Dispose();
			}
			catch (Exception e)
			{
				throw e;
			}
			finally
			{
				db.Close();
			}
			try
			{
				return System.Convert.ToInt32(returnVal);
			}
			catch{}
			return -1;
		}
		public static void Execute(OleDbCommand cmd)
		{
			try
			{
				cmd.Connection = db;
				db.Open();
				cmd.ExecuteNonQuery();
			}
			catch (Exception e)
			{
				throw e;
			}
			finally
			{
				db.Close();
			}
		}
		public static void Execute(string strSQL)
		{
			OleDbCommand dc = new OleDbCommand(strSQL,db);
			try
			{
				db.Open();
				dc.ExecuteNonQuery();
			}
			catch (Exception e)
			{
				throw e;
			}
			finally
			{
				db.Close();
			}
			dc.Dispose();
		}
		public static ArrayList GetFirstRow(OleDbCommand cmd) 
		{
			OleDbDataReader dr;
			ArrayList al = new ArrayList();
			try
			{
				cmd.Connection = db;
				db.Open();
				dr = cmd.ExecuteReader();
				if (dr.Read()) 
				{
					for(int i = 0 ; i < dr.FieldCount;i++ ) 
					{
						al.Add(dr.GetValue(i));
					}
				}
				dr.Close();
			}
			catch (Exception e)
			{
				throw e;
			}
			finally
			{
				db.Close();
			}
			return al;
		}
		public static ArrayList GetFirstRow(string strSelectCommand) 
		{
			OleDbCommand dc = new OleDbCommand(strSelectCommand,db);
			OleDbDataReader dr;
			ArrayList al = new ArrayList();
			try
			{
				db.Open();
				dr = dc.ExecuteReader();
				if (dr.Read()) 
				{
					for(int i = 0 ; i < dr.FieldCount;i++ ) 
					{
						al.Add(dr.GetValue(i));
					}
				}
				dr.Close();
			}
			catch (Exception e)
			{
				throw e;
			}
			finally
			{
				db.Close();
			}
			dc.Dispose();
			return al;
		}
		public static Queue GetFirstRowQ(string strSelectCommand)
		{
			OleDbCommand dc = new OleDbCommand(strSelectCommand,db);
			Queue q = new Queue();			
			OleDbDataReader dr;
			try
			{
				db.Open();
				dr = dc.ExecuteReader();
				if (dr.Read()) 
				{
					for(int i = 0 ; i < dr.FieldCount;i++ ) 
					{
						q.Enqueue(dr.GetValue(i));
					}
				}
			}
			catch (Exception e)
			{
				throw e;
			}
			finally
			{
				db.Close();
			}
			dc.Dispose();
			return q;
		}

		public static bool OutputRTF(string sql, string filename, string directory, bool includeHeaders, bool headersOnly)
		{
            return OutputRTF(new OleDbCommand(sql), filename, directory, includeHeaders, headersOnly);
		}

		public static bool OutputRTF(OleDbCommand cmd, string filename, string directory, bool includeHeaders, bool headersOnly)
		{
			return OutputRTF(cMyDB.GetDataSet(cmd), filename, directory, includeHeaders, headersOnly);
		}

		public static bool OutputRTF(DataSet ds, string filename, string directory, bool includeHeaders, bool headersOnly)
		{
			if (headersOnly && (!includeHeaders))
				return false;

			System.Text.StringBuilder sbRTF = new System.Text.StringBuilder();
			
			sbRTF.Append("{\\rtf1\\ansi\\ansicpg1252\\deff0{\\fonttbl{\\f0\\fnil\\fcharset0 Arial;}}{\\colortbl ;\\red0\\green0\\blue0;}\\trowd");
			
			int counter = 1;
			foreach(System.Data.DataColumn dc in ds.Tables[0].Columns)
			{
				sbRTF.Append("\\cellx" + (1400 * counter));
				counter++;
			}
			sbRTF.Append("\\pard\\intbl\\cf1\\lang1033");
				
			if (includeHeaders)
			{
				sbRTF.Append("\\b\\fs20 ");
			
				foreach(System.Data.DataColumn dc in ds.Tables[0].Columns)
				{
					sbRTF.Append(dc.ColumnName + "\\cell ");
				}

				sbRTF.Append("\\cf0\\b0\\fs24\\row");
			}

			if (!headersOnly )
			{
				System.Text.StringBuilder actualStr;

				foreach(System.Data.DataRow dr in ds.Tables[0].Rows)
				{
					sbRTF.Append("\\cf1\\fs20 ");
					for(counter = 0; counter < ds.Tables[0].Columns.Count; counter++)
					{
						switch(ds.Tables[0].Columns[counter].DataType.Name)
						{
							case "String":
								actualStr = new System.Text.StringBuilder(dr[counter].ToString());
								actualStr.Replace("\\", "\\\\");
								break;
							case "Boolean":
								if (dr[counter].Equals(true))
									actualStr = new System.Text.StringBuilder("Yes");
								else
									actualStr = new System.Text.StringBuilder("No");
								break;
							case "DateTime":
								if (!dr[counter].Equals(DBNull.Value))
								{
									actualStr = new System.Text.StringBuilder(((DateTime)dr[counter]).ToLongDateString());
									actualStr.Replace("\\", "\\\\");
								}
								else
									actualStr = new System.Text.StringBuilder(String.Empty);
								break;
							case "Decimal":
								if (!dr[counter].Equals(DBNull.Value))
									actualStr = new System.Text.StringBuilder("\\'A3" + ((decimal)dr[counter]).ToString("#,##0.00"));
								else
									actualStr = new System.Text.StringBuilder(String.Empty);	
								break;
							case "Single":
								if (!dr[counter].Equals(DBNull.Value))
									actualStr = new System.Text.StringBuilder(((Single)dr[counter]).ToString("#0.##%"));
								else
									actualStr = new System.Text.StringBuilder(String.Empty);	
								break;
							case "Int32":
								actualStr = new System.Text.StringBuilder(dr[counter].ToString());
								actualStr.Replace("\\", "\\\\");
								break;
							default:
								actualStr = new System.Text.StringBuilder(dr[counter].ToString());
								actualStr.Replace("\\", "\\\\");
								break;
						}
						actualStr.Replace("\r\n", "\\par ");
						actualStr.Replace("}", "\\}");
						actualStr.Replace("{", "\\{");
						sbRTF.Append("\\pard\\intbl{\\qr\\fs20\\f2\\cf0\\cb1 ");
						sbRTF.Append(actualStr.ToString());
						sbRTF.Append("\\cell}");
					}
					sbRTF.Append("\\cf0\\fs24\\row");
				}
			}
			sbRTF.Append("}");

			if (!directory.EndsWith("\\"))
			{
				directory += "\\";
			}

			try
			{
				System.IO.StreamWriter txtr = new System.IO.StreamWriter(new 
					System.IO.FileStream(directory + filename,
					System.IO.FileMode.OpenOrCreate, System.IO.FileAccess.Write));
				txtr.Write(sbRTF.ToString());
				txtr.Close();
			}
			catch (Exception ex)
			{
				System.Windows.Forms.MessageBox.Show(ex.Message, "Output Error");
				return false;
			}
			return true;
		}
	}
}
