using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace DebtManagerTest
{
	/// <summary>
	/// Summary description for frmAccounts.
	/// </summary>
	public class frmAccounts : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label lblStatus;
		private UtilityLibrary.WinControls.ButtonEx cmdOK;
		private UtilityLibrary.WinControls.ButtonEx cmdCancel;
		private System.Data.OleDb.OleDbCommand oleDbSelectCommand1;
		private System.Data.OleDb.OleDbCommand oleDbUpdateCommand1;
		private System.Data.OleDb.OleDbDataAdapter daAccount;
		private System.Data.OleDb.OleDbCommand cmdDeleteAccounts;
		private System.Data.OleDb.OleDbCommand cmdInsertAccounts;
		private DebtManagerTest.dsAccount dsAccount1;
		
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private Crownwood.Magic.Controls.TabControl tabControl1;
		private Crownwood.Magic.Controls.TabPage tabGeneral;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label1;
		private DebtManagerTest.LookupComboObjects.LookupCombo lookupCombo1;
		private System.Windows.Forms.DateTimePicker dateTimePicker1;
		private System.Windows.Forms.DateTimePicker dateTimePicker2;
		private System.Windows.Forms.TextBox textBox1;
		private bool Adding = false;

		public frmAccounts()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			daAccount.SelectCommand.Connection = cMyDB.NewConnection();
			daAccount.UpdateCommand.Connection = daAccount.SelectCommand.Connection;
			daAccount.InsertCommand.Connection = daAccount.SelectCommand.Connection;
			daAccount.DeleteCommand.Connection = daAccount.SelectCommand.Connection;
			this.tabGeneral.BindingContext = this.BindingContext;
			this.textBox1.DataBindings.Add(new CurrencyBinding("Text", this.dsAccount1, "LoanAccounts.AmountAdvanced"));
		}

		public void AddNew(Int32 CaseID)
		{
			dsAccount.LoanAccountsRow dr = dsAccount1.LoanAccounts.NewLoanAccountsRow();
			dr.BeginEdit();
			dr.CaseID = CaseID;
			dr.Created = DateTime.Now;
			dr.CreateUser = CSession.User.Username;
			dr.StartDate = DateTime.Today;
			dr.MaturityDate = DateTime.Today;
			dr.AccountType = "";
			dr.AmountAdvanced = 0;
			dr.EndEdit();
			dsAccount1.LoanAccounts.AddLoanAccountsRow(dr);
			Adding = true;
		}
		public void Edit(Int32 AccountID)
		{
			daAccount.SelectCommand.Parameters["ID"].Value = AccountID;
			daAccount.Fill(dsAccount1, "LoanAccounts"); 
			if (!dsAccount1.LoanAccounts.Rows[0]["LastUpdated"].Equals(DBNull.Value))
				this.lblStatus.Text = "Last Updated " + ((DateTime)dsAccount1.LoanAccounts.Rows[0]["LastUpdated"]).ToShortDateString() + " By " + (dsAccount1.LoanAccounts.Rows[0]["LastUser"] + "");
		}
		public void Delete(Int32 AccountID)
		{
			daAccount.SelectCommand.Parameters["ID"].Value = AccountID;
			daAccount.Fill(dsAccount1, "LoanAccounts");
			dsAccount.LoanAccountsRow dr = dsAccount1.LoanAccounts.FindByID(AccountID);
			dr.Delete();
			daAccount.Update(dsAccount1, "LoanAccounts");
		}
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.lblStatus = new System.Windows.Forms.Label();
			this.cmdOK = new UtilityLibrary.WinControls.ButtonEx();
			this.cmdCancel = new UtilityLibrary.WinControls.ButtonEx();
			this.daAccount = new System.Data.OleDb.OleDbDataAdapter();
			this.cmdDeleteAccounts = new System.Data.OleDb.OleDbCommand();
			this.cmdInsertAccounts = new System.Data.OleDb.OleDbCommand();
			this.oleDbSelectCommand1 = new System.Data.OleDb.OleDbCommand();
			this.oleDbUpdateCommand1 = new System.Data.OleDb.OleDbCommand();
			this.dsAccount1 = new DebtManagerTest.dsAccount();
			this.tabControl1 = new Crownwood.Magic.Controls.TabControl();
			this.tabGeneral = new Crownwood.Magic.Controls.TabPage();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.dateTimePicker2 = new System.Windows.Forms.DateTimePicker();
			this.dateTimePicker1 = new System.Windows.Forms.DateTimePicker();
			this.lookupCombo1 = new DebtManagerTest.LookupComboObjects.LookupCombo();
			this.label7 = new System.Windows.Forms.Label();
			this.label6 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			((System.ComponentModel.ISupportInitialize)(this.dsAccount1)).BeginInit();
			this.tabControl1.SuspendLayout();
			this.tabGeneral.SuspendLayout();
			this.SuspendLayout();
			// 
			// lblStatus
			// 
			this.lblStatus.Location = new System.Drawing.Point(1, 172);
			this.lblStatus.Name = "lblStatus";
			this.lblStatus.Size = new System.Drawing.Size(166, 27);
			this.lblStatus.TabIndex = 24;
			// 
			// cmdOK
			// 
			this.cmdOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.cmdOK.Location = new System.Drawing.Point(170, 175);
			this.cmdOK.Name = "cmdOK";
			this.cmdOK.Size = new System.Drawing.Size(68, 23);
			this.cmdOK.TabIndex = 23;
			this.cmdOK.Text = "OK";
			this.cmdOK.Click += new System.EventHandler(this.cmdOK_Click);
			// 
			// cmdCancel
			// 
			this.cmdCancel.CausesValidation = false;
			this.cmdCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.cmdCancel.Location = new System.Drawing.Point(245, 175);
			this.cmdCancel.Name = "cmdCancel";
			this.cmdCancel.Size = new System.Drawing.Size(70, 23);
			this.cmdCancel.TabIndex = 25;
			this.cmdCancel.Text = "Cancel";
			// 
			// daAccount
			// 
			this.daAccount.DeleteCommand = this.cmdDeleteAccounts;
			this.daAccount.InsertCommand = this.cmdInsertAccounts;
			this.daAccount.SelectCommand = this.oleDbSelectCommand1;
			this.daAccount.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																								new System.Data.Common.DataTableMapping("Table", "LoanAccounts", new System.Data.Common.DataColumnMapping[] {
																																																				new System.Data.Common.DataColumnMapping("AccountType", "AccountType"),
																																																				new System.Data.Common.DataColumnMapping("AmountAdvanced", "AmountAdvanced"),
																																																				new System.Data.Common.DataColumnMapping("CaseID", "CaseID"),
																																																				new System.Data.Common.DataColumnMapping("Created", "Created"),
																																																				new System.Data.Common.DataColumnMapping("CreateUser", "CreateUser"),
																																																				new System.Data.Common.DataColumnMapping("ID", "ID"),
																																																				new System.Data.Common.DataColumnMapping("LastUpdated", "LastUpdated"),
																																																				new System.Data.Common.DataColumnMapping("LastUser", "LastUser"),
																																																				new System.Data.Common.DataColumnMapping("MaturityDate", "MaturityDate"),
																																																				new System.Data.Common.DataColumnMapping("StartDate", "StartDate")})});
			this.daAccount.UpdateCommand = this.oleDbUpdateCommand1;
			this.daAccount.RowUpdated += new System.Data.OleDb.OleDbRowUpdatedEventHandler(this.daAccount_RowUpdated);
			// 
			// cmdDeleteAccounts
			// 
			this.cmdDeleteAccounts.CommandText = "DELETE FROM LoanAccounts WHERE (ID = ?) AND (LastUpdated = ? OR LastUpdated IS NU" +
				"LL AND ? IS NULL)";
			this.cmdDeleteAccounts.Parameters.Add(new System.Data.OleDb.OleDbParameter("ID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "ID", System.Data.DataRowVersion.Original, null));
			this.cmdDeleteAccounts.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUpdated", System.Data.OleDb.OleDbType.Date, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "LastUpdated", System.Data.DataRowVersion.Original, null));
			this.cmdDeleteAccounts.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_LastUpdated", System.Data.OleDb.OleDbType.Date, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "LastUpdated", System.Data.DataRowVersion.Original, null));
			// 
			// cmdInsertAccounts
			// 
			this.cmdInsertAccounts.CommandText = "INSERT INTO LoanAccounts(AccountType, AmountAdvanced, CaseID, Created, CreateUser" +
				", LastUpdated, LastUser, MaturityDate, StartDate) VALUES (?, ?, ?, ?, ?, ?, ?, ?" +
				", ?)";
			this.cmdInsertAccounts.Parameters.Add(new System.Data.OleDb.OleDbParameter("AccountType", System.Data.OleDb.OleDbType.VarWChar, 1, "AccountType"));
			this.cmdInsertAccounts.Parameters.Add(new System.Data.OleDb.OleDbParameter("AmountAdvanced", System.Data.OleDb.OleDbType.Currency, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(19)), ((System.Byte)(0)), "AmountAdvanced", System.Data.DataRowVersion.Current, null));
			this.cmdInsertAccounts.Parameters.Add(new System.Data.OleDb.OleDbParameter("CaseID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "CaseID", System.Data.DataRowVersion.Current, null));
			this.cmdInsertAccounts.Parameters.Add(new System.Data.OleDb.OleDbParameter("Created", System.Data.OleDb.OleDbType.Date, 0, "Created"));
			this.cmdInsertAccounts.Parameters.Add(new System.Data.OleDb.OleDbParameter("CreateUser", System.Data.OleDb.OleDbType.VarWChar, 12, "CreateUser"));
			this.cmdInsertAccounts.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUpdated", System.Data.OleDb.OleDbType.Date, 0, "LastUpdated"));
			this.cmdInsertAccounts.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUser", System.Data.OleDb.OleDbType.VarWChar, 12, "LastUser"));
			this.cmdInsertAccounts.Parameters.Add(new System.Data.OleDb.OleDbParameter("MaturityDate", System.Data.OleDb.OleDbType.DBDate, 0, "MaturityDate"));
			this.cmdInsertAccounts.Parameters.Add(new System.Data.OleDb.OleDbParameter("StartDate", System.Data.OleDb.OleDbType.DBDate, 0, "StartDate"));
			// 
			// oleDbSelectCommand1
			// 
			this.oleDbSelectCommand1.CommandText = "SELECT AccountType, AmountAdvanced, CaseID, Created, CreateUser, ID, LastUpdated," +
				" LastUser, MaturityDate, StartDate FROM LoanAccounts WHERE (ID = ?)";
			this.oleDbSelectCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("ID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "ID", System.Data.DataRowVersion.Current, null));
			// 
			// oleDbUpdateCommand1
			// 
			this.oleDbUpdateCommand1.CommandText = "UPDATE LoanAccounts SET AccountType = ?, AmountAdvanced = ?, CaseID = ?, Created " +
				"= ?, CreateUser = ?, LastUpdated = ?, LastUser = ?, MaturityDate = ?, StartDate " +
				"= ? WHERE (ID = ?) OR (LastUpdated = ? OR LastUpdated IS NULL AND ? IS NULL)";
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("AccountType", System.Data.OleDb.OleDbType.VarWChar, 1, "AccountType"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("AmountAdvanced", System.Data.OleDb.OleDbType.Currency, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(19)), ((System.Byte)(0)), "AmountAdvanced", System.Data.DataRowVersion.Current, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("CaseID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "CaseID", System.Data.DataRowVersion.Current, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Created", System.Data.OleDb.OleDbType.Date, 0, "Created"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("CreateUser", System.Data.OleDb.OleDbType.VarWChar, 12, "CreateUser"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUpdated", System.Data.OleDb.OleDbType.Date, 0, "LastUpdated"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUser", System.Data.OleDb.OleDbType.VarWChar, 12, "LastUser"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("MaturityDate", System.Data.OleDb.OleDbType.DBDate, 0, "MaturityDate"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("StartDate", System.Data.OleDb.OleDbType.DBDate, 0, "StartDate"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_ID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "ID", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_LastUpdated", System.Data.OleDb.OleDbType.Date, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "LastUpdated", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_LastUpdated1", System.Data.OleDb.OleDbType.Date, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "LastUpdated", System.Data.DataRowVersion.Original, null));
			// 
			// dsAccount1
			// 
			this.dsAccount1.DataSetName = "dsAccount";
			this.dsAccount1.Locale = new System.Globalization.CultureInfo("en-GB");
			this.dsAccount1.Namespace = "http://www.tempuri.org/dsAccount.xsd";
			// 
			// tabControl1
			// 
			this.tabControl1.Controls.AddRange(new System.Windows.Forms.Control[] {
																					  this.tabGeneral});
			this.tabControl1.Dock = System.Windows.Forms.DockStyle.Top;
			this.tabControl1.Font = new System.Drawing.Font("Tahoma", 11F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.World, ((System.Byte)(0)));
			this.tabControl1.Name = "tabControl1";
			this.tabControl1.PositionTop = true;
			this.tabControl1.SelectedIndex = 0;
			this.tabControl1.SelectedTab = this.tabGeneral;
			this.tabControl1.Size = new System.Drawing.Size(327, 158);
			this.tabControl1.TabIndex = 1;
			this.tabControl1.TabPages.AddRange(new Crownwood.Magic.Controls.TabPage[] {
																						  this.tabGeneral});
			// 
			// tabGeneral
			// 
			this.tabGeneral.Controls.AddRange(new System.Windows.Forms.Control[] {
																					 this.textBox1,
																					 this.dateTimePicker2,
																					 this.dateTimePicker1,
																					 this.lookupCombo1,
																					 this.label7,
																					 this.label6,
																					 this.label2,
																					 this.label1});
			this.tabGeneral.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.tabGeneral.Location = new System.Drawing.Point(0, 25);
			this.tabGeneral.Name = "tabGeneral";
			this.tabGeneral.Size = new System.Drawing.Size(327, 133);
			this.tabGeneral.TabIndex = 3;
			this.tabGeneral.Title = "General";
			// 
			// textBox1
			// 
			this.textBox1.Location = new System.Drawing.Point(140, 94);
			this.textBox1.Name = "textBox1";
			this.textBox1.TabIndex = 7;
			this.textBox1.Text = "";
			this.textBox1.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// dateTimePicker2
			// 
			this.dateTimePicker2.DataBindings.Add(new System.Windows.Forms.Binding("Value", this.dsAccount1, "LoanAccounts.MaturityDate"));
			this.dateTimePicker2.Format = System.Windows.Forms.DateTimePickerFormat.Short;
			this.dateTimePicker2.Location = new System.Drawing.Point(140, 70);
			this.dateTimePicker2.Name = "dateTimePicker2";
			this.dateTimePicker2.Size = new System.Drawing.Size(122, 20);
			this.dateTimePicker2.TabIndex = 6;
			// 
			// dateTimePicker1
			// 
			this.dateTimePicker1.DataBindings.Add(new System.Windows.Forms.Binding("Value", this.dsAccount1, "LoanAccounts.StartDate"));
			this.dateTimePicker1.Format = System.Windows.Forms.DateTimePickerFormat.Short;
			this.dateTimePicker1.Location = new System.Drawing.Point(140, 46);
			this.dateTimePicker1.Name = "dateTimePicker1";
			this.dateTimePicker1.Size = new System.Drawing.Size(122, 20);
			this.dateTimePicker1.TabIndex = 5;
			// 
			// lookupCombo1
			// 
			this.lookupCombo1.AllowUpdates = true;
			this.lookupCombo1.ComboValue = null;
			this.lookupCombo1.DataBindings.Add(new System.Windows.Forms.Binding("SelectedValue", this.dsAccount1, "LoanAccounts.AccountType"));
			this.lookupCombo1.DataBound = true;
			this.lookupCombo1.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.lookupCombo1.ExtraRefreshes = true;
			this.lookupCombo1.Location = new System.Drawing.Point(140, 22);
			this.lookupCombo1.LookupID = "AccountTypeLoans";
			this.lookupCombo1.Name = "lookupCombo1";
			this.lookupCombo1.Nullable = true;
			this.lookupCombo1.Size = new System.Drawing.Size(121, 21);
			this.lookupCombo1.TabIndex = 4;
			this.lookupCombo1.Validating += new System.ComponentModel.CancelEventHandler(this.lookupCombo1_Validating);
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(30, 93);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(101, 23);
			this.label7.TabIndex = 3;
			this.label7.Text = "Amount Advanced";
			this.label7.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(30, 68);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(101, 23);
			this.label6.TabIndex = 2;
			this.label6.Text = "Maturity Date";
			this.label6.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(30, 43);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(101, 23);
			this.label2.TabIndex = 1;
			this.label2.Text = "Start Date";
			this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(19, 18);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(112, 23);
			this.label1.TabIndex = 0;
			this.label1.Text = "Account Type";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// frmAccounts
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.cmdCancel;
			this.ClientSize = new System.Drawing.Size(327, 206);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.tabControl1,
																		  this.lblStatus,
																		  this.cmdOK,
																		  this.cmdCancel});
			this.Name = "frmAccounts";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Account Details";
			((System.ComponentModel.ISupportInitialize)(this.dsAccount1)).EndInit();
			this.tabControl1.ResumeLayout(false);
			this.tabGeneral.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void daAccount_RowUpdated(object sender, System.Data.OleDb.OleDbRowUpdatedEventArgs e)
		{
			if (e.RecordsAffected == 0)
			{
				DataSet ds = new DataSet();
				daAccount.SelectCommand.Parameters["ID"].Value = e.Row["ID"];
				daAccount.Fill(ds);
				if (ds.Tables[0].Rows.Count > 0)
					CUtil.RowUpdatedHandler(e, ds, daAccount);
				else
				{
					MessageBox.Show("This account has been deleted by another user, your changes could not be saved.","Update Error");
					e.Status = UpdateStatus.SkipCurrentRow;
				}
				ds.Dispose();
			}
		}

		private void cmdOK_Click(object sender, System.EventArgs e)
		{
			this.BindingContext[dsAccount1, "LoanAccounts"].EndCurrentEdit();
			if (dsAccount1.LoanAccounts.Rows[0].RowState != DataRowState.Unchanged)
			{
				dsAccount1.LoanAccounts.Rows[0]["LastUpdated"] = DateTime.Now;
				dsAccount1.LoanAccounts.Rows[0]["LastUser"] = CSession.User.Username;
				daAccount.Update(dsAccount1, "LoanAccounts");
			}
		}

		private void lookupCombo1_Validating(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if (lookupCombo1.SelectedIndex < 0)
			{
				e.Cancel = true;
				MessageBox.Show("Please select an account type.","Input Error");
			}
		}
	}
}
