using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace DebtManagerTest
{
	/// <summary>
	/// Summary description for frmPerson.
	/// </summary>
	public class frmPerson : System.Windows.Forms.Form
	{
		private DebtManagerTest.dsPeople dsPeople1;
		private System.Data.OleDb.OleDbDataAdapter daPerson;
		private System.Data.OleDb.OleDbCommand cmdDeletePerson;
		private System.Data.OleDb.OleDbCommand cmdInsertPerson;
		private System.Data.OleDb.OleDbCommand cmdSelectPerson;
		private System.Data.OleDb.OleDbCommand cmdUpdatePerson;
		private Crownwood.Magic.Controls.TabControl tabControl1;
		private Crownwood.Magic.Controls.TabPage tabGeneral;
		private Crownwood.Magic.Controls.TabPage tabNotes;
		private System.Windows.Forms.TextBox textBox6;
		private DebtManagerTest.LookupComboObjects.LookupCombo lookupCombo3;
		private System.Windows.Forms.TextBox textBox2;
		private System.Windows.Forms.TextBox textBox1;
		private DebtManagerTest.LookupComboObjects.LookupCombo cboTitle;
		private DebtManagerTest.LookupComboObjects.LookupCombo cboPersonType;
		private System.Windows.Forms.Label lblStatus;
		private UtilityLibrary.WinControls.ButtonEx cmdOK;
		private UtilityLibrary.WinControls.ButtonEx cmdCancel;
		private System.Windows.Forms.TextBox txtNotes;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.TextBox txtHomePhone;
		private System.Windows.Forms.CheckBox chkResident;
		private System.Windows.Forms.TextBox txtPostCode;
		private System.Windows.Forms.TextBox txtAddress;
		private System.Windows.Forms.Label lblPostCode;
		private System.Windows.Forms.Label lblHomePhone;
		private System.Windows.Forms.Label lblAddress;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private bool Adding = false;

		public frmPerson()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			daPerson.SelectCommand.Connection = cMyDB.NewConnection();
			daPerson.UpdateCommand.Connection = daPerson.SelectCommand.Connection;
			daPerson.DeleteCommand.Connection = daPerson.SelectCommand.Connection;
			daPerson.InsertCommand.Connection = daPerson.SelectCommand.Connection;
			tabGeneral.BindingContext = this.BindingContext;
			tabNotes.BindingContext = this.BindingContext;
		}

		public void AddNew(Int32 CaseID, string PersonType)
		{
			AddNew(CaseID);
			dsPeople1.People.Rows[0].BeginEdit();
			dsPeople1.People.Rows[0]["PersonType"] = PersonType;
			dsPeople1.People.Rows[0].EndEdit();	
			this.Text = "Enter New " + cboPersonType.Text + " Details"; 
		}
		public void AddNew(Int32 CaseID)
		{
			dsPeople.PeopleRow dr = dsPeople1.People.NewPeopleRow();
			dr.BeginEdit();
			dr.CaseID = CaseID;
			dr.PersonType = "B";
			dr.Created = DateTime.Now;
			dr.CreateUser = CSession.User.Username;
			dr.AddressAsProperty = true;
			dr.EndEdit();
			dsPeople1.People.AddPeopleRow(dr);
			Adding = true;
			this.Text = "Enter New " + cboPersonType.Text + " Details"; 
		}
		public void Edit(Int32 PersonID)
		{
			daPerson.SelectCommand.Parameters["ID"].Value = PersonID;
			daPerson.Fill(dsPeople1, "People");
			if (!dsPeople1.People.Rows[0]["LastUpdated"].Equals(DBNull.Value))
				this.lblStatus.Text = "Last Updated " + ((DateTime)dsPeople1.People.Rows[0]["LastUpdated"]).ToShortDateString() + " By " + (dsPeople1.People.Rows[0]["LastUser"] + "");
			this.Text = "Edit " + cboPersonType.Text + " Details"; 
		}
		public void Delete(Int32 PersonID)
		{
			daPerson.SelectCommand.Parameters["ID"].Value = PersonID;
			daPerson.Fill(dsPeople1, "People");
			dsPeople.PeopleRow dr = dsPeople1.People.FindByID(PersonID);
			dr.Delete();
			daPerson.Update(dsPeople1, "People");
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.dsPeople1 = new DebtManagerTest.dsPeople();
			this.daPerson = new System.Data.OleDb.OleDbDataAdapter();
			this.cmdDeletePerson = new System.Data.OleDb.OleDbCommand();
			this.cmdInsertPerson = new System.Data.OleDb.OleDbCommand();
			this.cmdSelectPerson = new System.Data.OleDb.OleDbCommand();
			this.cmdUpdatePerson = new System.Data.OleDb.OleDbCommand();
			this.tabControl1 = new Crownwood.Magic.Controls.TabControl();
			this.tabGeneral = new Crownwood.Magic.Controls.TabPage();
			this.lblPostCode = new System.Windows.Forms.Label();
			this.lblHomePhone = new System.Windows.Forms.Label();
			this.label8 = new System.Windows.Forms.Label();
			this.label7 = new System.Windows.Forms.Label();
			this.label6 = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.lblAddress = new System.Windows.Forms.Label();
			this.textBox6 = new System.Windows.Forms.TextBox();
			this.txtHomePhone = new System.Windows.Forms.TextBox();
			this.lookupCombo3 = new DebtManagerTest.LookupComboObjects.LookupCombo();
			this.chkResident = new System.Windows.Forms.CheckBox();
			this.txtPostCode = new System.Windows.Forms.TextBox();
			this.txtAddress = new System.Windows.Forms.TextBox();
			this.textBox2 = new System.Windows.Forms.TextBox();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.cboTitle = new DebtManagerTest.LookupComboObjects.LookupCombo();
			this.cboPersonType = new DebtManagerTest.LookupComboObjects.LookupCombo();
			this.tabNotes = new Crownwood.Magic.Controls.TabPage();
			this.txtNotes = new System.Windows.Forms.TextBox();
			this.lblStatus = new System.Windows.Forms.Label();
			this.cmdOK = new UtilityLibrary.WinControls.ButtonEx();
			this.cmdCancel = new UtilityLibrary.WinControls.ButtonEx();
			((System.ComponentModel.ISupportInitialize)(this.dsPeople1)).BeginInit();
			this.tabControl1.SuspendLayout();
			this.tabGeneral.SuspendLayout();
			this.tabNotes.SuspendLayout();
			this.SuspendLayout();
			// 
			// dsPeople1
			// 
			this.dsPeople1.DataSetName = "dsPeople";
			this.dsPeople1.Locale = new System.Globalization.CultureInfo("en-GB");
			this.dsPeople1.Namespace = "http://www.tempuri.org/dsPeople.xsd";
			// 
			// daPerson
			// 
			this.daPerson.DeleteCommand = this.cmdDeletePerson;
			this.daPerson.InsertCommand = this.cmdInsertPerson;
			this.daPerson.SelectCommand = this.cmdSelectPerson;
			this.daPerson.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																							   new System.Data.Common.DataTableMapping("Table", "People", new System.Data.Common.DataColumnMapping[] {
																																																		 new System.Data.Common.DataColumnMapping("Address", "Address"),
																																																		 new System.Data.Common.DataColumnMapping("AddressAsProperty", "AddressAsProperty"),
																																																		 new System.Data.Common.DataColumnMapping("CaseID", "CaseID"),
																																																		 new System.Data.Common.DataColumnMapping("Created", "Created"),
																																																		 new System.Data.Common.DataColumnMapping("CreateUser", "CreateUser"),
																																																		 new System.Data.Common.DataColumnMapping("EarningsAfterTax", "EarningsAfterTax"),
																																																		 new System.Data.Common.DataColumnMapping("Employer", "Employer"),
																																																		 new System.Data.Common.DataColumnMapping("EmploymentDetails", "EmploymentDetails"),
																																																		 new System.Data.Common.DataColumnMapping("ID", "ID"),
																																																		 new System.Data.Common.DataColumnMapping("Initials", "Initials"),
																																																		 new System.Data.Common.DataColumnMapping("LastUpdated", "LastUpdated"),
																																																		 new System.Data.Common.DataColumnMapping("LastUser", "LastUser"),
																																																		 new System.Data.Common.DataColumnMapping("MaritalStatus", "MaritalStatus"),
																																																		 new System.Data.Common.DataColumnMapping("Notes", "Notes"),
																																																		 new System.Data.Common.DataColumnMapping("PersonType", "PersonType"),
																																																		 new System.Data.Common.DataColumnMapping("PostCode", "PostCode"),
																																																		 new System.Data.Common.DataColumnMapping("SameAsPropertyTelephone", "SameAsPropertyTelephone"),
																																																		 new System.Data.Common.DataColumnMapping("Surname", "Surname"),
																																																		 new System.Data.Common.DataColumnMapping("TelephoneHome", "TelephoneHome"),
																																																		 new System.Data.Common.DataColumnMapping("TelephoneWork", "TelephoneWork"),
																																																		 new System.Data.Common.DataColumnMapping("Title", "Title")})});
			this.daPerson.UpdateCommand = this.cmdUpdatePerson;
			this.daPerson.RowUpdated += new System.Data.OleDb.OleDbRowUpdatedEventHandler(this.daPerson_RowUpdated);
			// 
			// cmdDeletePerson
			// 
			this.cmdDeletePerson.CommandText = "DELETE FROM People WHERE (ID = ?) AND (LastUpdated = ? OR LastUpdated IS NULL AND" +
				" ? IS NULL)";
			this.cmdDeletePerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("ID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "ID", System.Data.DataRowVersion.Original, null));
			this.cmdDeletePerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUpdated", System.Data.OleDb.OleDbType.Date, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "LastUpdated", System.Data.DataRowVersion.Original, null));
			this.cmdDeletePerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_LastUpdated", System.Data.OleDb.OleDbType.Date, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "LastUpdated", System.Data.DataRowVersion.Original, null));
			// 
			// cmdInsertPerson
			// 
			this.cmdInsertPerson.CommandText = @"INSERT INTO People(Address, AddressAsProperty, CaseID, Created, CreateUser, EarningsAfterTax, Employer, EmploymentDetails, Initials, LastUpdated, LastUser, MaritalStatus, Notes, PersonType, PostCode, SameAsPropertyTelephone, Surname, TelephoneHome, TelephoneWork, Title) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";
			this.cmdInsertPerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("Address", System.Data.OleDb.OleDbType.VarWChar, 255, "Address"));
			this.cmdInsertPerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("AddressAsProperty", System.Data.OleDb.OleDbType.Boolean, 2, "AddressAsProperty"));
			this.cmdInsertPerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("CaseID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "CaseID", System.Data.DataRowVersion.Current, null));
			this.cmdInsertPerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("Created", System.Data.OleDb.OleDbType.Date, 0, "Created"));
			this.cmdInsertPerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("CreateUser", System.Data.OleDb.OleDbType.VarWChar, 12, "CreateUser"));
			this.cmdInsertPerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("EarningsAfterTax", System.Data.OleDb.OleDbType.Currency, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(19)), ((System.Byte)(0)), "EarningsAfterTax", System.Data.DataRowVersion.Current, null));
			this.cmdInsertPerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("Employer", System.Data.OleDb.OleDbType.VarWChar, 10, "Employer"));
			this.cmdInsertPerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("EmploymentDetails", System.Data.OleDb.OleDbType.VarWChar, 50, "EmploymentDetails"));
			this.cmdInsertPerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("Initials", System.Data.OleDb.OleDbType.VarWChar, 5, "Initials"));
			this.cmdInsertPerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUpdated", System.Data.OleDb.OleDbType.Date, 0, "LastUpdated"));
			this.cmdInsertPerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUser", System.Data.OleDb.OleDbType.VarWChar, 12, "LastUser"));
			this.cmdInsertPerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("MaritalStatus", System.Data.OleDb.OleDbType.VarWChar, 12, "MaritalStatus"));
			this.cmdInsertPerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("Notes", System.Data.OleDb.OleDbType.VarWChar, 0, "Notes"));
			this.cmdInsertPerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("PersonType", System.Data.OleDb.OleDbType.VarWChar, 1, "PersonType"));
			this.cmdInsertPerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("PostCode", System.Data.OleDb.OleDbType.VarWChar, 12, "PostCode"));
			this.cmdInsertPerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("SameAsPropertyTelephone", System.Data.OleDb.OleDbType.Boolean, 2, "SameAsPropertyTelephone"));
			this.cmdInsertPerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("Surname", System.Data.OleDb.OleDbType.VarWChar, 50, "Surname"));
			this.cmdInsertPerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("TelephoneHome", System.Data.OleDb.OleDbType.VarWChar, 15, "TelephoneHome"));
			this.cmdInsertPerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("TelephoneWork", System.Data.OleDb.OleDbType.VarWChar, 15, "TelephoneWork"));
			this.cmdInsertPerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("Title", System.Data.OleDb.OleDbType.VarWChar, 5, "Title"));
			// 
			// cmdSelectPerson
			// 
			this.cmdSelectPerson.CommandText = @"SELECT Address, AddressAsProperty, CaseID, Created, CreateUser, EarningsAfterTax, Employer, EmploymentDetails, ID, Initials, LastUpdated, LastUser, MaritalStatus, Notes, PersonType, PostCode, SameAsPropertyTelephone, Surname, TelephoneHome, TelephoneWork, Title FROM People WHERE (ID = ?)";
			this.cmdSelectPerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("ID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "ID", System.Data.DataRowVersion.Current, null));
			// 
			// cmdUpdatePerson
			// 
			this.cmdUpdatePerson.CommandText = @"UPDATE People SET Address = ?, AddressAsProperty = ?, CaseID = ?, Created = ?, CreateUser = ?, EarningsAfterTax = ?, Employer = ?, EmploymentDetails = ?, Initials = ?, LastUpdated = ?, LastUser = ?, MaritalStatus = ?, Notes = ?, PersonType = ?, PostCode = ?, SameAsPropertyTelephone = ?, Surname = ?, TelephoneHome = ?, TelephoneWork = ?, Title = ? WHERE (ID = ?) AND (LastUpdated = ? OR LastUpdated IS NULL AND ? IS NULL)";
			this.cmdUpdatePerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("Address", System.Data.OleDb.OleDbType.VarWChar, 255, "Address"));
			this.cmdUpdatePerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("AddressAsProperty", System.Data.OleDb.OleDbType.Boolean, 2, "AddressAsProperty"));
			this.cmdUpdatePerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("CaseID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "CaseID", System.Data.DataRowVersion.Current, null));
			this.cmdUpdatePerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("Created", System.Data.OleDb.OleDbType.Date, 0, "Created"));
			this.cmdUpdatePerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("CreateUser", System.Data.OleDb.OleDbType.VarWChar, 12, "CreateUser"));
			this.cmdUpdatePerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("EarningsAfterTax", System.Data.OleDb.OleDbType.Currency, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(19)), ((System.Byte)(0)), "EarningsAfterTax", System.Data.DataRowVersion.Current, null));
			this.cmdUpdatePerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("Employer", System.Data.OleDb.OleDbType.VarWChar, 10, "Employer"));
			this.cmdUpdatePerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("EmploymentDetails", System.Data.OleDb.OleDbType.VarWChar, 50, "EmploymentDetails"));
			this.cmdUpdatePerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("Initials", System.Data.OleDb.OleDbType.VarWChar, 5, "Initials"));
			this.cmdUpdatePerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUpdated", System.Data.OleDb.OleDbType.Date, 0, "LastUpdated"));
			this.cmdUpdatePerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUser", System.Data.OleDb.OleDbType.VarWChar, 12, "LastUser"));
			this.cmdUpdatePerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("MaritalStatus", System.Data.OleDb.OleDbType.VarWChar, 12, "MaritalStatus"));
			this.cmdUpdatePerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("Notes", System.Data.OleDb.OleDbType.VarWChar, 0, "Notes"));
			this.cmdUpdatePerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("PersonType", System.Data.OleDb.OleDbType.VarWChar, 1, "PersonType"));
			this.cmdUpdatePerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("PostCode", System.Data.OleDb.OleDbType.VarWChar, 12, "PostCode"));
			this.cmdUpdatePerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("SameAsPropertyTelephone", System.Data.OleDb.OleDbType.Boolean, 2, "SameAsPropertyTelephone"));
			this.cmdUpdatePerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("Surname", System.Data.OleDb.OleDbType.VarWChar, 50, "Surname"));
			this.cmdUpdatePerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("TelephoneHome", System.Data.OleDb.OleDbType.VarWChar, 15, "TelephoneHome"));
			this.cmdUpdatePerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("TelephoneWork", System.Data.OleDb.OleDbType.VarWChar, 15, "TelephoneWork"));
			this.cmdUpdatePerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("Title", System.Data.OleDb.OleDbType.VarWChar, 5, "Title"));
			this.cmdUpdatePerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_ID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "ID", System.Data.DataRowVersion.Original, null));
			this.cmdUpdatePerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_LastUpdated", System.Data.OleDb.OleDbType.Date, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "LastUpdated", System.Data.DataRowVersion.Original, null));
			this.cmdUpdatePerson.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_LastUpdated1", System.Data.OleDb.OleDbType.Date, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "LastUpdated", System.Data.DataRowVersion.Original, null));
			// 
			// tabControl1
			// 
			this.tabControl1.Controls.AddRange(new System.Windows.Forms.Control[] {
																					  this.tabGeneral,
																					  this.tabNotes});
			this.tabControl1.Dock = System.Windows.Forms.DockStyle.Top;
			this.tabControl1.Font = new System.Drawing.Font("Tahoma", 11F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.World, ((System.Byte)(0)));
			this.tabControl1.Name = "tabControl1";
			this.tabControl1.PositionTop = true;
			this.tabControl1.SelectedIndex = 0;
			this.tabControl1.SelectedTab = this.tabGeneral;
			this.tabControl1.Size = new System.Drawing.Size(333, 303);
			this.tabControl1.TabIndex = 11;
			this.tabControl1.TabPages.AddRange(new Crownwood.Magic.Controls.TabPage[] {
																						  this.tabGeneral,
																						  this.tabNotes});
			// 
			// tabGeneral
			// 
			this.tabGeneral.Controls.AddRange(new System.Windows.Forms.Control[] {
																					 this.lblPostCode,
																					 this.lblHomePhone,
																					 this.label8,
																					 this.label7,
																					 this.label6,
																					 this.label5,
																					 this.label4,
																					 this.label3,
																					 this.lblAddress,
																					 this.textBox6,
																					 this.txtHomePhone,
																					 this.lookupCombo3,
																					 this.chkResident,
																					 this.txtPostCode,
																					 this.txtAddress,
																					 this.textBox2,
																					 this.textBox1,
																					 this.cboTitle,
																					 this.cboPersonType});
			this.tabGeneral.Location = new System.Drawing.Point(0, 25);
			this.tabGeneral.Name = "tabGeneral";
			this.tabGeneral.Size = new System.Drawing.Size(333, 278);
			this.tabGeneral.TabIndex = 3;
			this.tabGeneral.Title = "General";
			// 
			// lblPostCode
			// 
			this.lblPostCode.BackColor = System.Drawing.SystemColors.Control;
			this.lblPostCode.ForeColor = System.Drawing.SystemColors.InactiveCaption;
			this.lblPostCode.Location = new System.Drawing.Point(12, 161);
			this.lblPostCode.Name = "lblPostCode";
			this.lblPostCode.Size = new System.Drawing.Size(99, 23);
			this.lblPostCode.TabIndex = 31;
			this.lblPostCode.Text = "Post Code";
			this.lblPostCode.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblHomePhone
			// 
			this.lblHomePhone.BackColor = System.Drawing.SystemColors.Control;
			this.lblHomePhone.ForeColor = System.Drawing.SystemColors.InactiveCaption;
			this.lblHomePhone.Location = new System.Drawing.Point(12, 186);
			this.lblHomePhone.Name = "lblHomePhone";
			this.lblHomePhone.Size = new System.Drawing.Size(99, 23);
			this.lblHomePhone.TabIndex = 30;
			this.lblHomePhone.Text = "Home Phone No";
			this.lblHomePhone.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// label8
			// 
			this.label8.Location = new System.Drawing.Point(12, 211);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(99, 23);
			this.label8.TabIndex = 29;
			this.label8.Text = "Work Phone No";
			this.label8.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(12, 236);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(99, 23);
			this.label7.TabIndex = 28;
			this.label7.Text = "Marital Status";
			this.label7.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(188, 46);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(40, 17);
			this.label6.TabIndex = 27;
			this.label6.Text = "Initials";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(62, 70);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(49, 12);
			this.label5.TabIndex = 26;
			this.label5.Text = "Surname";
			this.label5.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(24, 46);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(87, 15);
			this.label4.TabIndex = 25;
			this.label4.Text = "Title";
			this.label4.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(7, 23);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(104, 14);
			this.label3.TabIndex = 24;
			this.label3.Text = "Connection to Case";
			this.label3.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblAddress
			// 
			this.lblAddress.BackColor = System.Drawing.SystemColors.Control;
			this.lblAddress.ForeColor = System.Drawing.SystemColors.InactiveCaption;
			this.lblAddress.Location = new System.Drawing.Point(30, 114);
			this.lblAddress.Name = "lblAddress";
			this.lblAddress.Size = new System.Drawing.Size(81, 17);
			this.lblAddress.TabIndex = 23;
			this.lblAddress.Text = "Address";
			this.lblAddress.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// textBox6
			// 
			this.textBox6.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsPeople1, "People.TelephoneWork"));
			this.textBox6.Location = new System.Drawing.Point(123, 213);
			this.textBox6.Name = "textBox6";
			this.textBox6.TabIndex = 19;
			this.textBox6.Text = "";
			// 
			// txtHomePhone
			// 
			this.txtHomePhone.BackColor = System.Drawing.SystemColors.Control;
			this.txtHomePhone.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsPeople1, "People.TelephoneHome"));
			this.txtHomePhone.Enabled = false;
			this.txtHomePhone.Location = new System.Drawing.Point(123, 187);
			this.txtHomePhone.Name = "txtHomePhone";
			this.txtHomePhone.TabIndex = 18;
			this.txtHomePhone.Text = "";
			// 
			// lookupCombo3
			// 
			this.lookupCombo3.AllowUpdates = true;
			this.lookupCombo3.ComboValue = null;
			this.lookupCombo3.DataBindings.Add(new System.Windows.Forms.Binding("SelectedValue", this.dsPeople1, "People.MaritalStatus"));
			this.lookupCombo3.DataBound = true;
			this.lookupCombo3.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.lookupCombo3.ExtraRefreshes = true;
			this.lookupCombo3.Location = new System.Drawing.Point(123, 239);
			this.lookupCombo3.LookupID = "MaritalStatus";
			this.lookupCombo3.Name = "lookupCombo3";
			this.lookupCombo3.Nullable = true;
			this.lookupCombo3.TabIndex = 20;
			// 
			// chkResident
			// 
			this.chkResident.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.chkResident.DataBindings.Add(new System.Windows.Forms.Binding("Checked", this.dsPeople1, "People.AddressAsProperty"));
			this.chkResident.Location = new System.Drawing.Point(6, 92);
			this.chkResident.Name = "chkResident";
			this.chkResident.Size = new System.Drawing.Size(135, 20);
			this.chkResident.TabIndex = 15;
			this.chkResident.Text = "Resident At Property";
			this.chkResident.CheckedChanged += new System.EventHandler(this.chkResident_CheckedChanged);
			// 
			// txtPostCode
			// 
			this.txtPostCode.BackColor = System.Drawing.SystemColors.Control;
			this.txtPostCode.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsPeople1, "People.PostCode"));
			this.txtPostCode.Enabled = false;
			this.txtPostCode.Location = new System.Drawing.Point(123, 161);
			this.txtPostCode.Name = "txtPostCode";
			this.txtPostCode.TabIndex = 17;
			this.txtPostCode.Text = "";
			// 
			// txtAddress
			// 
			this.txtAddress.BackColor = System.Drawing.SystemColors.Control;
			this.txtAddress.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsPeople1, "People.Address"));
			this.txtAddress.Enabled = false;
			this.txtAddress.Location = new System.Drawing.Point(123, 113);
			this.txtAddress.Multiline = true;
			this.txtAddress.Name = "txtAddress";
			this.txtAddress.Size = new System.Drawing.Size(162, 43);
			this.txtAddress.TabIndex = 16;
			this.txtAddress.Text = "";
			// 
			// textBox2
			// 
			this.textBox2.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsPeople1, "People.Surname"));
			this.textBox2.Location = new System.Drawing.Point(123, 69);
			this.textBox2.Name = "textBox2";
			this.textBox2.TabIndex = 14;
			this.textBox2.Text = "";
			// 
			// textBox1
			// 
			this.textBox1.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsPeople1, "People.Initials"));
			this.textBox1.Location = new System.Drawing.Point(236, 44);
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(62, 21);
			this.textBox1.TabIndex = 13;
			this.textBox1.Text = "";
			// 
			// cboTitle
			// 
			this.cboTitle.AllowUpdates = true;
			this.cboTitle.ComboValue = null;
			this.cboTitle.DataBindings.Add(new System.Windows.Forms.Binding("SelectedValue", this.dsPeople1, "People.Title"));
			this.cboTitle.DataBound = true;
			this.cboTitle.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cboTitle.ExtraRefreshes = true;
			this.cboTitle.Location = new System.Drawing.Point(123, 44);
			this.cboTitle.LookupID = "Title";
			this.cboTitle.Name = "cboTitle";
			this.cboTitle.Nullable = false;
			this.cboTitle.Size = new System.Drawing.Size(55, 21);
			this.cboTitle.TabIndex = 12;
			// 
			// cboPersonType
			// 
			this.cboPersonType.AllowUpdates = true;
			this.cboPersonType.ComboValue = null;
			this.cboPersonType.DataBindings.Add(new System.Windows.Forms.Binding("SelectedValue", this.dsPeople1, "People.PersonType"));
			this.cboPersonType.DataBound = true;
			this.cboPersonType.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cboPersonType.ExtraRefreshes = true;
			this.cboPersonType.Location = new System.Drawing.Point(123, 19);
			this.cboPersonType.LookupID = "PersonType";
			this.cboPersonType.Name = "cboPersonType";
			this.cboPersonType.Nullable = false;
			this.cboPersonType.TabIndex = 11;
			this.cboPersonType.SelectionChangeCommitted += new System.EventHandler(this.cboPersonType_SelectionChangeCommitted);
			// 
			// tabNotes
			// 
			this.tabNotes.Controls.AddRange(new System.Windows.Forms.Control[] {
																				   this.txtNotes});
			this.tabNotes.Location = new System.Drawing.Point(0, 25);
			this.tabNotes.Name = "tabNotes";
			this.tabNotes.Selected = false;
			this.tabNotes.Size = new System.Drawing.Size(333, 278);
			this.tabNotes.TabIndex = 4;
			this.tabNotes.Title = "Notes";
			// 
			// txtNotes
			// 
			this.txtNotes.AcceptsReturn = true;
			this.txtNotes.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsPeople1, "People.Notes"));
			this.txtNotes.Dock = System.Windows.Forms.DockStyle.Fill;
			this.txtNotes.Multiline = true;
			this.txtNotes.Name = "txtNotes";
			this.txtNotes.Size = new System.Drawing.Size(333, 278);
			this.txtNotes.TabIndex = 0;
			this.txtNotes.Text = "";
			// 
			// lblStatus
			// 
			this.lblStatus.Location = new System.Drawing.Point(10, 313);
			this.lblStatus.Name = "lblStatus";
			this.lblStatus.Size = new System.Drawing.Size(166, 27);
			this.lblStatus.TabIndex = 20;
			// 
			// cmdOK
			// 
			this.cmdOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.cmdOK.Location = new System.Drawing.Point(179, 316);
			this.cmdOK.Name = "cmdOK";
			this.cmdOK.Size = new System.Drawing.Size(68, 23);
			this.cmdOK.TabIndex = 19;
			this.cmdOK.Text = "OK";
			this.cmdOK.Click += new System.EventHandler(this.cmdOK_Click);
			// 
			// cmdCancel
			// 
			this.cmdCancel.CausesValidation = false;
			this.cmdCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.cmdCancel.Location = new System.Drawing.Point(254, 316);
			this.cmdCancel.Name = "cmdCancel";
			this.cmdCancel.Size = new System.Drawing.Size(70, 23);
			this.cmdCancel.TabIndex = 21;
			this.cmdCancel.Text = "Cancel";
			// 
			// frmPerson
			// 
			this.AcceptButton = this.cmdOK;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.cmdCancel;
			this.ClientSize = new System.Drawing.Size(333, 346);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.lblStatus,
																		  this.cmdOK,
																		  this.cmdCancel,
																		  this.tabControl1});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "frmPerson";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			((System.ComponentModel.ISupportInitialize)(this.dsPeople1)).EndInit();
			this.tabControl1.ResumeLayout(false);
			this.tabGeneral.ResumeLayout(false);
			this.tabNotes.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void chkResident_CheckedChanged(object sender, System.EventArgs e)
		{
			if (chkResident.Checked)
			{
				this.txtAddress.Enabled = false;
				this.txtAddress.BackColor = System.Drawing.SystemColors.Control;
				this.txtPostCode.Enabled = false;
				this.txtPostCode.BackColor = System.Drawing.SystemColors.Control;
				this.txtHomePhone.Enabled = false;
				this.txtHomePhone.BackColor = System.Drawing.SystemColors.Control;
				this.lblAddress.ForeColor = System.Drawing.SystemColors.InactiveCaption;
				this.lblPostCode.ForeColor = System.Drawing.SystemColors.InactiveCaption;
				this.lblHomePhone.ForeColor = System.Drawing.SystemColors.InactiveCaption;
			}
			else
			{
				this.txtAddress.Enabled = true;
				this.txtAddress.BackColor = System.Drawing.SystemColors.Window;
				this.txtPostCode.Enabled = true;
				this.txtPostCode.BackColor = System.Drawing.SystemColors.Window;
				this.txtHomePhone.Enabled = true;
				this.txtHomePhone.BackColor = System.Drawing.SystemColors.Window;
				this.lblAddress.ForeColor = System.Drawing.SystemColors.ControlText;
				this.lblPostCode.ForeColor = System.Drawing.SystemColors.ControlText;
				this.lblHomePhone.ForeColor = System.Drawing.SystemColors.ControlText;
			}
		}

		private void cboPersonType_SelectionChangeCommitted(object sender, System.EventArgs e)
		{
			if (Adding)
				this.Text = "Enter New " + cboPersonType.Text + " Details"; 
			else
				this.Text = "Edit " + cboPersonType.Text + " Details";
		}

		private void cmdOK_Click(object sender, System.EventArgs e)
		{
			this.BindingContext[dsPeople1, "People"].EndCurrentEdit();
			if (dsPeople1.People.Rows[0].RowState != DataRowState.Unchanged)
			{
				dsPeople1.People.Rows[0]["SameAsPropertyTelephone"] = dsPeople1.People.Rows[0]["AddressAsProperty"];
				if (((bool)dsPeople1.People.Rows[0]["AddressAsProperty"])==true)
				{
					dsPeople1.People.Rows[0]["Address"] = DBNull.Value;
					dsPeople1.People.Rows[0]["PostCode"] = DBNull.Value;
					dsPeople1.People.Rows[0]["TelephoneHome"] = DBNull.Value;
				}
				dsPeople1.People.Rows[0]["LastUpdated"] = DateTime.Now;
				dsPeople1.People.Rows[0]["LastUser"] = CSession.User.Username;
				daPerson.Update(dsPeople1, "People");
			}
		}

		private void daPerson_RowUpdated(object sender, System.Data.OleDb.OleDbRowUpdatedEventArgs e)
		{
			if (e.RecordsAffected == 0)
			{
				DataSet ds = new DataSet();
				daPerson.SelectCommand.Parameters["ID"].Value = e.Row["ID"];
				daPerson.Fill(ds);
				if (ds.Tables[0].Rows.Count > 0)
					CUtil.RowUpdatedHandler(e, ds, daPerson);
				else
				{
					MessageBox.Show("This person has been deleted by another user, your changes could not be saved.","Update Error");
					e.Status = UpdateStatus.SkipCurrentRow;
				}
				ds.Dispose();
			}
			if (e.StatementType != StatementType.Delete)
			{
				if (e.Row["PersonType"].Equals("B"))
					MainForm.BorrowersChanged = true;
			}
			else
				MainForm.BorrowersChanged = true;
		}
	}
}
