using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace DebtManagerTest
{
	/// <summary>
	/// Summary description for frmUsers.
	/// </summary>
	public class frmUsers : System.Windows.Forms.Form
	{
		private UtilityLibrary.WinControls.ListViewEx lvwUsers;
		private UtilityLibrary.WinControls.ButtonEx cmdClose;
		private System.Data.OleDb.OleDbDataAdapter daUsers;
		private System.Data.OleDb.OleDbCommand oleDbSelectCommand1;
		private System.Data.OleDb.OleDbCommand oleDbInsertCommand1;
		private System.Data.OleDb.OleDbCommand oleDbUpdateCommand1;
		private System.Data.OleDb.OleDbCommand oleDbDeleteCommand1;
		private Crownwood.Magic.Menus.MenuCommand mnuDelete;
		private Crownwood.Magic.Menus.MenuCommand mnuRefresh;
		private Crownwood.Magic.Menus.MenuCommand mnuNew;
		private Crownwood.Magic.Menus.MenuCommand mnuEdit;
		private System.Windows.Forms.ColumnHeader columnHeader1;
		private System.Windows.Forms.ColumnHeader columnHeader2;
		private DebtManagerTest.dsUsers dsUsers1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private UtilityLibrary.WinControls.ButtonEx cmdLookupSecurity;
		private UtilityLibrary.WinControls.ButtonEx buttonEx1;
		private Crownwood.Magic.Menus.PopupMenu pm;

		public frmUsers()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			daUsers.SelectCommand.Connection = cMyDB.NewConnection();
			daUsers.DeleteCommand.Connection = daUsers.SelectCommand.Connection;
			daUsers.InsertCommand.Connection = daUsers.SelectCommand.Connection;
			daUsers.UpdateCommand.Connection = daUsers.SelectCommand.Connection;

			daUsers.Fill(dsUsers1, "Users");
			FillUserList();
			lvwUsers.Columns[0].Width = lvwUsers.Width * 2/5;
			lvwUsers.Columns[1].Width = lvwUsers.Width * 2/5;

			pm = new Crownwood.Magic.Menus.PopupMenu();
			pm.MenuCommands.Add(mnuNew);
			pm.MenuCommands.Add(mnuEdit);
			pm.MenuCommands.Add(mnuDelete);
			pm.MenuCommands.Add(mnuRefresh);
		}

		private void FillUserList()
		{
			lvwUsers.Items.Clear();
			foreach (dsUsers.UsersRow ur in dsUsers1.Users)
			{
				ListViewItem temp = null;
				if(!ur.IsUserNameNull())
					temp = lvwUsers.Items.Add(ur.UserName);
				else
					temp = lvwUsers.Items.Add(string.Empty);
				if(!ur.IsDescriptionNull())
					temp.SubItems.Add(ur.Description);
				temp.Tag = ur;
			}
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(frmUsers));
			this.lvwUsers = new UtilityLibrary.WinControls.ListViewEx();
			this.columnHeader1 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader2 = new System.Windows.Forms.ColumnHeader();
			this.cmdClose = new UtilityLibrary.WinControls.ButtonEx();
			this.daUsers = new System.Data.OleDb.OleDbDataAdapter();
			this.oleDbDeleteCommand1 = new System.Data.OleDb.OleDbCommand();
			this.oleDbInsertCommand1 = new System.Data.OleDb.OleDbCommand();
			this.oleDbSelectCommand1 = new System.Data.OleDb.OleDbCommand();
			this.oleDbUpdateCommand1 = new System.Data.OleDb.OleDbCommand();
			this.mnuDelete = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuRefresh = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuNew = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuEdit = new Crownwood.Magic.Menus.MenuCommand();
			this.dsUsers1 = new DebtManagerTest.dsUsers();
			this.cmdLookupSecurity = new UtilityLibrary.WinControls.ButtonEx();
			this.buttonEx1 = new UtilityLibrary.WinControls.ButtonEx();
			((System.ComponentModel.ISupportInitialize)(this.dsUsers1)).BeginInit();
			this.SuspendLayout();
			// 
			// lvwUsers
			// 
			this.lvwUsers.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.lvwUsers.CheckBookEvenRowBackColor = System.Drawing.Color.Empty;
			this.lvwUsers.CheckBookEvenRowForeColor = System.Drawing.Color.Empty;
			this.lvwUsers.CheckBookLookEnabled = false;
			this.lvwUsers.CheckBookOddRowBackColor = System.Drawing.Color.Empty;
			this.lvwUsers.CheckBookOddRowForeColor = System.Drawing.Color.Empty;
			this.lvwUsers.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																					   this.columnHeader1,
																					   this.columnHeader2});
			this.lvwUsers.FullRowSelect = true;
			this.lvwUsers.HeaderColor = System.Drawing.Color.Empty;
			this.lvwUsers.HeaderImageList = null;
			this.lvwUsers.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
			this.lvwUsers.Location = new System.Drawing.Point(4, 6);
			this.lvwUsers.MultiSelect = false;
			this.lvwUsers.Name = "lvwUsers";
			this.lvwUsers.PaintSortedColumnBackground = true;
			this.lvwUsers.Size = new System.Drawing.Size(283, 223);
			this.lvwUsers.SortingEnabled = true;
			this.lvwUsers.SortOrder = System.Windows.Forms.SortOrder.Ascending;
			this.lvwUsers.TabIndex = 0;
			this.lvwUsers.View = System.Windows.Forms.View.Details;
			this.lvwUsers.Resize += new System.EventHandler(this.lvwUsers_Resize);
			this.lvwUsers.MouseUp += new System.Windows.Forms.MouseEventHandler(this.lvwUsers_MouseUp);
			// 
			// columnHeader1
			// 
			this.columnHeader1.Text = "User name";
			// 
			// columnHeader2
			// 
			this.columnHeader2.Text = "User Level";
			// 
			// cmdClose
			// 
			this.cmdClose.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right);
			this.cmdClose.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.cmdClose.Location = new System.Drawing.Point(213, 238);
			this.cmdClose.Name = "cmdClose";
			this.cmdClose.TabIndex = 1;
			this.cmdClose.Text = "Close ";
			// 
			// daUsers
			// 
			this.daUsers.DeleteCommand = this.oleDbDeleteCommand1;
			this.daUsers.InsertCommand = this.oleDbInsertCommand1;
			this.daUsers.SelectCommand = this.oleDbSelectCommand1;
			this.daUsers.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																							  new System.Data.Common.DataTableMapping("Table", "Users", new System.Data.Common.DataColumnMapping[] {
																																																	   new System.Data.Common.DataColumnMapping("ID", "ID"),
																																																	   new System.Data.Common.DataColumnMapping("UserLevel", "UserLevel"),
																																																	   new System.Data.Common.DataColumnMapping("UserName", "UserName"),
																																																	   new System.Data.Common.DataColumnMapping("Password", "Password")})});
			this.daUsers.UpdateCommand = this.oleDbUpdateCommand1;
			// 
			// oleDbDeleteCommand1
			// 
			this.oleDbDeleteCommand1.CommandText = "DELETE FROM Users WHERE (ID = ?)";
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_ID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "ID", System.Data.DataRowVersion.Original, null));
			// 
			// oleDbInsertCommand1
			// 
			this.oleDbInsertCommand1.CommandText = "INSERT INTO Users(UserLevel, UserName, [Password]) VALUES (?, ?, ?)";
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("UserLevel", System.Data.OleDb.OleDbType.UnsignedTinyInt, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(3)), ((System.Byte)(0)), "UserLevel", System.Data.DataRowVersion.Current, null));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("UserName", System.Data.OleDb.OleDbType.VarWChar, 12, "UserName"));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Password", System.Data.OleDb.OleDbType.VarWChar, 50, "Password"));
			// 
			// oleDbSelectCommand1
			// 
			this.oleDbSelectCommand1.CommandText = "SELECT Users.ID, Users.UserLevel, Users.UserName, Users.[Password], Users.Manager" +
				", UserLevelLookup.Description FROM Users LEFT OUTER JOIN UserLevelLookup ON User" +
				"s.UserLevel = UserLevelLookup.ID";
			// 
			// oleDbUpdateCommand1
			// 
			this.oleDbUpdateCommand1.CommandText = "UPDATE Users SET UserLevel = ?, UserName = ?, [Password] = ? WHERE (ID = ?)";
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("UserLevel", System.Data.OleDb.OleDbType.UnsignedTinyInt, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(3)), ((System.Byte)(0)), "UserLevel", System.Data.DataRowVersion.Current, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("UserName", System.Data.OleDb.OleDbType.VarWChar, 12, "UserName"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Password", System.Data.OleDb.OleDbType.VarWChar, 50, "Password"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_ID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "ID", System.Data.DataRowVersion.Original, null));
			// 
			// mnuDelete
			// 
			this.mnuDelete.Description = "Delete this user";
			this.mnuDelete.Text = "&Delete User";
			this.mnuDelete.Click += new System.EventHandler(this.mnuDelete_Click);
			// 
			// mnuRefresh
			// 
			this.mnuRefresh.Description = "Refresh this list";
			this.mnuRefresh.Text = "&Refresh";
			this.mnuRefresh.Click += new System.EventHandler(this.mnuRefresh_Click);
			// 
			// mnuNew
			// 
			this.mnuNew.Description = "New user";
			this.mnuNew.Text = "&New User";
			this.mnuNew.Click += new System.EventHandler(this.mnuNew_Click);
			// 
			// mnuEdit
			// 
			this.mnuEdit.Description = "Edit User";
			this.mnuEdit.Text = "&Edit User";
			this.mnuEdit.Click += new System.EventHandler(this.mnuEdit_Click);
			// 
			// dsUsers1
			// 
			this.dsUsers1.DataSetName = "dsUsers";
			this.dsUsers1.Locale = new System.Globalization.CultureInfo("en-GB");
			this.dsUsers1.Namespace = "http://www.tempuri.org/dsUsers.xsd";
			// 
			// cmdLookupSecurity
			// 
			this.cmdLookupSecurity.Location = new System.Drawing.Point(5, 238);
			this.cmdLookupSecurity.Name = "cmdLookupSecurity";
			this.cmdLookupSecurity.Size = new System.Drawing.Size(87, 23);
			this.cmdLookupSecurity.TabIndex = 2;
			this.cmdLookupSecurity.Text = "Lookup Security ";
			this.cmdLookupSecurity.Click += new System.EventHandler(this.cmdLookupSecurity_Click);
			// 
			// buttonEx1
			// 
			this.buttonEx1.Location = new System.Drawing.Point(110, 238);
			this.buttonEx1.Name = "buttonEx1";
			this.buttonEx1.Size = new System.Drawing.Size(83, 23);
			this.buttonEx1.TabIndex = 3;
			this.buttonEx1.Text = "Access Levels ";
			this.buttonEx1.Click += new System.EventHandler(this.buttonEx1_Click);
			// 
			// frmUsers
			// 
			this.AcceptButton = this.cmdClose;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 268);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.buttonEx1,
																		  this.cmdLookupSecurity,
																		  this.cmdClose,
																		  this.lvwUsers});
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "frmUsers";
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Hide;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "User Management";
			((System.ComponentModel.ISupportInitialize)(this.dsUsers1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void mnuDelete_Click(object sender, System.EventArgs e)
		{
			if(((dsUsers.UsersRow)lvwUsers.Tag).ID == CSession.User.UserID)
			{
				MessageBox.Show("You cannot delete your own user account.", "Invalid Selection");
				return;
			}
			else if (((dsUsers.UsersRow)lvwUsers.Tag).UserLevel > CSession.User.UserLevel)
			{
				MessageBox.Show("You cannot delete a user account with a higher level than yours.", "Invalid Selection");
				return;
			}
			else 
			{
				((dsUsers.UsersRow)lvwUsers.Tag).Delete();
			}
			try
			{
				daUsers.Update(dsUsers1, "Users");
			}
			catch (Exception ex)
			{
				MessageBox.Show("The selected user could not be deleted. [" + ex.Message + "]", "Delete Error");
			}
			mnuRefresh_Click(sender, e);
		}

		private void mnuNew_Click(object sender, System.EventArgs e)
		{
			frmUser frm = new frmUser(null);

			while (frm.users.Users[0].IsUserLevelNull() || frm.users.Users[0].IsUserNameNull())
			{
				if (frm.ShowDialog() != DialogResult.OK)
					return;
				if (frm.users.Users[0].IsUserLevelNull() || frm.users.Users[0].IsUserNameNull())
				{
					MessageBox.Show("One or more fields have been left blank. Please provide a user name and security level","Invalid Data");
					continue;
				}
				if (!frm.users.Users[0].IsUserLevelNull())
				{
					if (frm.users.Users[0].UserLevel > CSession.User.UserLevel)
					{
						MessageBox.Show("You cannot give a user account a higher access level than you have.","Invalid Data");	
						frm.users.Users[0].SetUserLevelNull();
					}
				}
			}
			try
			{
				daUsers.Update(frm.users, "Users" );
			}
			catch (Exception ex)
			{
				MessageBox.Show("The selected user could not be deleted. [" + ex.Message + "]", "Delete Error");
			}
			frm.Dispose();
			mnuRefresh_Click(sender, e);
		}

		private void mnuEdit_Click(object sender, System.EventArgs e)
		{
			dsUsers.UsersRow row = (dsUsers.UsersRow)lvwUsers.Tag;
			if (row.UserLevel > CSession.User.UserLevel)
			{
				MessageBox.Show("You cannot edit a user with a higher security level than your own.","Invalid Data");
				return;
			}
			frmUser frm = new frmUser(row);
			
			do 
			{
				if (frm.ShowDialog() != DialogResult.OK)
					return;
				if (frm.users.Users[0].IsUserLevelNull() || frm.users.Users[0].IsUserNameNull())
				{
					MessageBox.Show("One or more fields have been left blank. Please provide a user name and security level","Invalid Data");
					continue;
				}
				if (!frm.users.Users[0].IsUserLevelNull())
				{
					if (frm.users.Users[0].UserLevel > CSession.User.UserLevel)
					{
						MessageBox.Show("You cannot give a user account a higher access level than you have.","Invalid Data");
						frm.users.Users[0].SetUserLevelNull();
					}
				}
			}
			while (frm.users.Users[0].IsUserLevelNull() || frm.users.Users[0].IsUserNameNull());
			
			try
			{
				daUsers.Update(frm.users, "Users");
			}
			catch (Exception ex)
			{
				MessageBox.Show("The selected user could not be deleted. [" + ex.Message + "]", "Delete Error");
			}
			frm.Dispose();
			mnuRefresh_Click(sender, e);
		}

		private void mnuRefresh_Click(object sender, System.EventArgs e)
		{
			dsUsers1.Clear();
			daUsers.Fill(dsUsers1, "Users");
			FillUserList();
		}

		private void lvwUsers_Resize(object sender, System.EventArgs e)
		{
			lvwUsers.Columns[0].Width = lvwUsers.Width * 2/5;
			lvwUsers.Columns[1].Width = lvwUsers.Width * 2/5;
		}

		private void lvwUsers_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if (e.Button == MouseButtons.Right)
			{
				if (lvwUsers.GetItemAt(e.X,e.Y)!=null)
				{
					lvwUsers.Tag = lvwUsers.GetItemAt(e.X,e.Y).Tag;
					mnuEdit.Visible = true;
					mnuDelete.Visible = true;
				}
				else
				{
					mnuEdit.Visible = false;
					mnuDelete.Visible = false;
				}
				pm.TrackPopup(lvwUsers.PointToScreen(new Point(e.X,e.Y)));
			}
		}

		private void cmdLookupSecurity_Click(object sender, System.EventArgs e)
		{
			frmLookupSettings frm = new frmLookupSettings();
			frm.ShowDialog();
			frm.Dispose();
			lvwUsers.Focus();
		}

		private void buttonEx1_Click(object sender, System.EventArgs e)
		{
			frmSecurityLevels frm = new frmSecurityLevels();
			frm.ShowDialog();
			frm.Dispose();
			lvwUsers.Focus();
		}
	}
}
