VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsDiary"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Private mDB As DBConnection
Private WithEvents mList As ListView
Attribute mList.VB_VarHelpID = -1
Private WithEvents mDTP As DTPicker
Attribute mDTP.VB_VarHelpID = -1
Private OtherLists As New Collection

Public Event CaseSelected(PropID As Long)

Public Property Set theList(tList As ListView)
    Set mList = tList
End Property

Public Property Get theList() As ListView
    Set theList = mList
End Property

Public Property Set ThePicker(tDTP As DTPicker)
    Set mDTP = tDTP
    mDTP.Value = Date
End Property

Public Property Get ThePicker() As DTPicker
    Set ThePicker = mDTP
End Property

Public Property Get DBCon() As DBConnection
    Set DBCon = mDB
End Property

Public Property Set DBCon(DBConnObj As DBConnection)
    Set mDB = DBConnObj
End Property

Public Function GetCurrentPropID() As Long
    Dim tempkey As String
    
    tempkey = mList.SelectedItem.Key
    GetCurrentPropID = CLng(Mid(Left(tempkey, InStr(tempkey, "|D") - 1), 5))
End Function

Public Function GetCurrentDiaryID() As Long
    Dim tempkey As String
    
    tempkey = mList.SelectedItem.Key
    GetCurrentDiaryID = CLng(Mid(tempkey, InStr(tempkey, "|D") + 2))
End Function

Public Sub FillDiary()
    Dim rs As adodb.Recordset
    Dim tempkey, Img As Long
    
    mList.ListItems.Clear
    
    Set rs = mDB.OpenReadOnlySQL("Select d.ActionDate, d.Description, " & _
        "a.Special,p.AccountNumber, p.PropID,d.DiaryID From (tblProperties as P " & _
        "right join tblDiary as d on p.propID = d.propID) inner join " & _
        "tblActions as a on a.actionID = d.actiontype WHERE d.completed = false " & _
        "AND d.ActionDAte <= #" & Format(mDTP.Value, "mm/dd/yyyy") & "# And (UserDiary is null or UserDiary = " & User.UserID & ") ORDER BY ActionDate DESC")
    
    If rs.EOF Then
        mList.ListItems.Add , "NA", "No Actions Due"
        mList.ListItems.Add , "NEW", "Double click to create a new entry", , 16
        mList.View = lvwList
    Else
        mList.View = lvwReport
    End If
    
    Do While Not rs.EOF
        Select Case rs!special
        Case "WRITE"
            Img = 17
        Case "MEETING"
            Img = 20
        Case "PHONE"
            Img = 18
        Case "REVIEW"
            Img = 19
        Case Else
            Img = 21
        End Select
        tempkey = "PROP" & nz(rs!PropID, 0) & "|D" & rs!DiaryID
        mList.ListItems.Add , tempkey, rs!ActionDate, , Img
        If Not IsNull(rs!AccountNumber) Then
            mList.ListItems(tempkey).SubItems(1) = rs!AccountNumber
        End If
        mList.ListItems(tempkey).SubItems(2) = nz(rs!Description, "")
        rs.MoveNext
    Loop
        
    rs.Close
        
    If OtherLists.Count > 0 Then
        Dim x As ListView
        For Each x In OtherLists
            FillListView x, x.Tag
        Next
    End If
        
End Sub

Private Sub mDTP_Change()
    FillDiary
End Sub

Private Sub mList_DblClick()
    Dim TempID As Long, tempkey As String
    
    tempkey = mList.SelectedItem.Key
    If tempkey = "NA" Or tempkey = "NEW" Then
        If tempkey = "NEW" Then
            Diarise 0
        End If
    Else
        TempID = CLng(Mid(Left(tempkey, InStr(tempkey, "|D") - 1), 5))
        If TempID > 0 Then
            RaiseEvent CaseSelected(TempID)
        Else
            EditDiary GetCurrentDiaryID
        End If
    End If
    
End Sub

Private Sub mList_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    If Not theList.HitTest(x, y) Is Nothing And Button = vbRightButton Then
        frmDebtMain.PopupMenu frmDebtMain.mnuDiaryOptions
    ElseIf Button = vbRightButton Then
        frmDebtMain.PopupMenu frmDebtMain.mnuBasicDiaryOptions
    End If
End Sub

Private Sub mList_OLEDragDrop(Data As MSComctlLib.DataObject, Effect As Long, Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim tempLong As Long, tempstr As String
    tempstr = Data.GetData(vbCFText)
    If Left(tempstr, 4) = "PROP" Then
        tempLong = InStr(tempstr, "|")
        If tempLong > 0 Then
            tempstr = Left(tempstr, tempLong - 1)
        End If
        Diarise CLng(Mid(tempstr, 5))
    End If
End Sub

Private Sub mList_OLEDragOver(Data As MSComctlLib.DataObject, Effect As Long, Button As Integer, Shift As Integer, x As Single, y As Single, State As Integer)
    If Data.GetFormat(vbCFText) Then
        If Left(Data.GetData(vbCFText), 4) = "PROP" Then
            Effect = vbDropEffectCopy
        Else
            Effect = vbDropEffectNone
        End If
    Else
        Effect = vbDropEffectNone
    End If
End Sub

Public Function Diarise(PropID As Long)
    Dim x As frmDiarise
    Dim rs As adodb.Recordset
    
    Set x = New frmDiarise
    If PropID > 0 Then
        x.ClientSelected = PropID
    End If
    x.Show vbModal
    If x.SelectedOK Then
        Set rs = DBCon.OpenTable("tblDiary")
        
        rs.AddNew
            If x.cboClient.ListIndex >= 0 Then
                rs!PropID = x.cboClient.ItemData(x.cboClient.ListIndex)
            Else
                rs!PropID = Null
            End If
            rs!Description = x.txtDescription.Text
            rs!ActionType = x.cboAction.ItemData(x.cboAction.ListIndex)
            rs!LastUpdated = Now
            rs!LastUser = User.UserName
            rs!ActionDate = x.ActionDate.Value
            If x.cboUser.ItemData(x.cboUser.ListIndex) < 0 Then
                rs!userDiary = Null
            Else
                rs!userDiary = x.cboUser.ItemData(x.cboUser.ListIndex)
            End If
        rs.Update
    
        rs.Close
        Set rs = Nothing
        FillDiary
    End If
    Unload x
    Set x = Nothing
End Function

Public Function EditDiary(DiaryID As Long) As Boolean
    Dim x As frmDiarise
    Dim rs As adodb.Recordset, complete As Boolean
    
    Set rs = DBCon.OpenReadOnlySQL("Select Completed from tblDiary Where DiaryID = " & DiaryID)
    If Not rs.EOF Then
        rs.MoveFirst
        complete = rs!completed
    End If
    rs.Close
    
    If complete Then
        CompleteDiary DiaryID
    Else
        If DiaryID > 0 Then
            Set x = New frmDiarise
            x.EditDiary = DiaryID
            If x.ErrorLoadingDiary Then
                MsgBox "An error occured trying to load the diary item details."
                Unload x
                Exit Function
            End If
            x.Show vbModal
            If x.SelectedOK Then
                Set rs = DBCon.OpenDynaset("Select * From tblDiary Where DiaryID = " & DiaryID)
                
                If Not rs.EOF Then
                    rs.MoveFirst
                        If x.cboClient.ListIndex >= 0 Then
                            rs!PropID = x.cboClient.ItemData(x.cboClient.ListIndex)
                        Else
                            rs!PropID = Null
                        End If
                        rs!Description = x.txtDescription.Text
                        rs!ActionType = x.cboAction.ItemData(x.cboAction.ListIndex)
                        rs!LastUpdated = Now
                        rs!LastUser = User.UserName
                        rs!ActionDate = x.ActionDate.Value
                        If x.cboUser.ItemData(x.cboUser.ListIndex) < 0 Then
                            rs!userDiary = Null
                        Else
                            rs!userDiary = x.cboUser.ItemData(x.cboUser.ListIndex)
                        End If
                    rs.Update
                    rs.Close
                Else
                    rs.Close
                    MsgBox "Couldn't open data to update record."
                End If
                
                Set rs = Nothing
                FillDiary
            End If
            Unload x
            Set x = Nothing
        End If
    End If
End Function

Public Function Undiarise(DiaryID As Long)
    If DiaryID > 0 Then
        DBCon.db.Execute "Delete From tblDiary Where DiaryID = " & DiaryID
        DBCon.ReleaseDB
        FillDiary
    End If
End Function

Public Function Uncomplete(DiaryID As Long)
    If DiaryID > 0 Then
        DBCon.db.Execute "Update tblDiary SET Completed = False, DateActioned = Null, lastUpdated = now, lastUser = '" & ElimQuotes(User.UserName) & "' Where DiaryID = " & DiaryID
        DBCon.ReleaseDB
        FillDiary
    End If
End Function

Public Function CompleteDiary(DiaryID As Long) As Boolean
    Dim x As frmCompleteDiary
    Dim rs As adodb.Recordset
    
    If DiaryID > 0 Then
        Set x = New frmCompleteDiary
        x.CompleteDiary = DiaryID
        If x.ErrorLoadingDiary Then
            MsgBox "An error occured trying to load the diary item details."
            Unload x
            Exit Function
        End If
        x.Show vbModal
        If x.SelectedOK Then
            Set rs = DBCon.OpenDynaset("Select * From tblDiary Where DiaryID = " & DiaryID)
            
            If Not rs.EOF Then
                rs.MoveFirst
                    rs!Description = x.txtDescription.Text
                    rs!ActionType = x.cboAction.ItemData(x.cboAction.ListIndex)
                    rs!LastUpdated = Now
                    rs!LastUser = User.UserName
                    rs!DateActioned = x.DateActioned.Value
                    rs!Notes = x.txtNotes.Text
                    rs!completed = True
                rs.Update
                rs.Close
            Else
                rs.Close
                MsgBox "Couldn't open data to update record."
            End If
            
            Set rs = Nothing
            FillDiary
        End If
        Unload x
        Set x = Nothing
    End If

End Function

Public Sub FillListView(theList As ListView, PropID As Long)
    Dim rs As adodb.Recordset
    Dim tempkey, Img As Long
    
    theList.ListItems.Clear
    
    Set rs = mDB.OpenReadOnlySQL("Select d.*, " & _
        "a.Special, a.ActionType as ActionDesc From tblDiary as d inner join " & _
        "tblActions as a on a.actionID = d.actiontype WHERE PropID = " & PropID & _
        " AND (UserDiary is null or UserDiary = " & User.UserID & " or Completed = true) ORDER BY ActionDate DESC")
    
    If rs.EOF Then
        theList.ListItems.Add , "NA", "Nothing Due or Recorded"
        theList.ListItems.Add , "NEWJ" & PropID, "Double click to create a new journal entry", , 16
        theList.ListItems.Add , "NEWD" & PropID, "Double click to add a diary entry for this client", , 16
        theList.View = lvwList
    Else
        theList.View = lvwReport
        If theList.ColumnHeaders.Count <> 5 Then
            theList.ColumnHeaders.Clear
            theList.ColumnHeaders.Add , "DATE", "Date"
            theList.ColumnHeaders("DATE").Width = 1275
            theList.ColumnHeaders.Add , "ACTION", "Action"
            theList.ColumnHeaders("ACTION").Width = 795
            theList.ColumnHeaders.Add , "DESC", "Description"
            theList.ColumnHeaders("DESC").Width = 1620
            theList.ColumnHeaders.Add , "TAKEN", "Notes"
            theList.ColumnHeaders("TAKEN").Width = 1515
            theList.ColumnHeaders.Add , "DONEDATE", "Completed"
            theList.ColumnHeaders("DONEDATE").Width = 1065
        End If
    End If
    
    Do While Not rs.EOF
        Select Case rs!special
        Case "WRITE"
            Img = 17
        Case "MEETING"
            Img = 20
        Case "PHONE"
            Img = 18
        Case "REVIEW"
            Img = 19
        Case Else
            Img = 21
        End Select
        tempkey = "D" & rs!DiaryID
        theList.ListItems.Add , tempkey, rs!ActionDate, , Img
        theList.ListItems(tempkey).SubItems(1) = nz(rs!ActionDesc, "")
        theList.ListItems(tempkey).SubItems(2) = nz(rs!Description, "")
        theList.ListItems(tempkey).SubItems(3) = Left(nz(rs!Notes, ""), 50)
        theList.ListItems(tempkey).SubItems(4) = nz(rs!DateActioned, "")
        rs.MoveNext
    Loop
        
    rs.Close
        
    AddToListViews theList
    theList.Tag = PropID
    
End Sub

Private Sub AddToListViews(theList As ListView)
    
    Dim found As Boolean, x As ListView
    
    For Each x In OtherLists
        If theList.hwnd = x.hwnd Then found = True
    Next
    
    If Not found Then OtherLists.Add theList

End Sub

Public Sub RemoveFromListViews(theList As ListView)
    
    Dim x
    
    For x = 1 To OtherLists.Count
        If OtherLists(x).hwnd = theList.hwnd Then OtherLists.Remove x
    Next

End Sub

Public Sub DoDoubleClickForListView(szSelectedItemKey As String)
    Dim TempID As Long, tempkey As String
    
    tempkey = szSelectedItemKey
    If tempkey = "NA" Or Left(tempkey, 3) = "NEW" Then
        If Left(tempkey, 4) = "NEWJ" Then
            NewJournalEntry CLng(Mid(tempkey, 5))
        ElseIf Left(tempkey, 4) = "NEWD" Then
            Diarise CLng(Mid(tempkey, 5))
        End If
    Else
        TempID = CLng(Mid(tempkey, 2))
        EditDiary TempID
    End If
    
End Sub

Public Sub DoOLEDragOverForListView(Data As MSComctlLib.DataObject)
    If Data.GetFormat(vbCFText) Then
        If Left(Data.GetData(vbCFText), 4) = "PROP" Then
            Effect = vbDropEffectCopy
        Else
            Effect = vbDropEffectNone
        End If
    Else
        Effect = vbDropEffectNone
    End If
End Sub

Public Sub DoOLEDropEventForListView(Data As MSComctlLib.DataObject)
    Dim tempLong As Long, tempstr As String
    tempstr = Data.GetData(vbCFText)
    If Left(tempstr, 4) = "PROP" Then
        tempLong = InStr(tempstr, "|")
        If tempLong > 0 Then
            tempstr = Left(tempstr, tempLong - 1)
        End If
        Diarise CLng(Mid(tempstr, 5))
    End If
End Sub

Public Sub NewJournalEntry(PropID As Long)
    
    Dim x As frmCompleteDiary
    Dim rs As adodb.Recordset
    Dim TempClient
    
    If PropID > 0 Then
        Set rs = DBCon.OpenReadOnlySQL("Select AccountNumber From tblProperties where PropID = " & PropID)
        If Not rs.EOF Then
            rs.MoveFirst
            TempClient = rs!AccountNumber
        End If
        rs.Close
        Set rs = Nothing
    Else
        TempClient = "General"
    End If
    
    Set x = New frmCompleteDiary
    x.Client = TempClient
    x.lblLastUpdate.Visible = False
    x.Caption = "Record Journal Entry"
    x.Show vbModal
    If x.SelectedOK Then
        Set rs = DBCon.OpenTable("tblDiary")
        rs.AddNew
            If PropID > 0 Then
                rs!PropID = PropID
            Else
                rs!PropID = Null
            End If
            rs!Description = x.txtDescription.Text
            rs!ActionType = x.cboAction.ItemData(x.cboAction.ListIndex)
            rs!LastUpdated = Now
            rs!userDiary = User.UserID
            rs!LastUser = User.UserName
            rs!ActionDate = x.DateActioned.Value
            rs!DateActioned = x.DateActioned.Value
            rs!Notes = x.txtNotes.Text
            rs!completed = True
        rs.Update
        rs.Close
        
        Set rs = Nothing
        FillDiary
    End If
    Unload x
    Set x = Nothing
    
End Sub
